function checkSOC(ParameterFileReg,ParameterFileEst,AllCoefFile,NTAKES,DR,MDR, ...
    TALT,NCSMAX,Price,AllFirmsProducts,nFirms,costs,XMAT,WGT,NP,NCS)

global NV NF 
global IDV IDF
global NDRAWS
global PV PVI
global dsm dcs alt asymmetry
global OProd OFirm

eval(ParameterFileReg);
eval(ParameterFileEst);

Mark=XMAT(:,mar);   %Vector of market data
nMarkets=max(Mark); %Number of markets

for m=1:nMarkets
    Index=Mark==m;  %Index of observations relevant for current market

    [XMATc,Sc,Groupc,DRc,MDRc,NPc,NCSMAXc,WGTc]= ...
        marketdata(NTAKES,DR,MDR,TALT,XMAT,WGT,NP,NCS,Index);    

    %Construct data matrices
    [Xc XFc]=simulationdata(NPc,NCSMAXc,XMATc,TALT);

    [Share,GradS,Hess]=SOCMatrix(XMATc,NPc,NCSMAXc,Xc,XFc,DRc,MDRc,...
         Sc,Groupc,AllCoefFile,R,AllFirmsProducts,TALT,IDV);
   
    %TALTxTALTxTALT matrix of margins (varying over 3rd dimension)
    margins=reshape(repmat((Price(:,m)-costs(:,m))',[TALT*TALT 1])...
        ,[TALT TALT TALT]);

    %TALTxTALTxTALTxNCSMAXxNP matrix of summed up Hessian
    Weight=permute(repmat(WGTc', [1 TALT TALT TALT NCSMAXc]),[2 3 4 5 1]);

    %TALTxTALTxTALT matrix of summed up Hessian
    SHess=sum(sum(Hess.*Weight,4),5);

    %TALTxTALT - one element is
    %sum_iinF d2s_i/dp_jdp_k*(p_i-c_i)
    temp=sum(margins.*SHess,3);

    %TALTxTALTxNCSMAXxNP matrix of summed up Hessian
    Weight=permute(repmat(WGTc', [1 TALT TALT NCSMAXc]),[2 3 4 1]);

    %TALTx1 vector of market shares
    MShare=sum(sum(Share.*permute(repmat(WGTc',[1 TALT NCSMAXc]),[2 3 1]),2),3);

    %TALTx1 vector of FOC residuals
    Res=MShare+sum(sum(GradS.*Weight,3),4)*(Price(:,m)-costs(:,m));

    %NALTMAXxNALTMAX Jacobian for FOCS
    J=sum(sum(GradS.*Weight,3),4)'+sum(sum(GradS.*Weight,3),4)+temp;
    
    findex=(1:nFirms)';

    NO=length(OFirm);
    for i=1:NO
       findex=findex(findex~=OFirm(i));
    end

    nInFirms=length(findex);

    for ff=1:nInFirms
        
        f=findex(ff);
        % Index of Products owned by firm f
        FProd=AllFirmsProducts{f};

%         % FOCs for current firm
%         Resc=Res(FProd);
        % SOC for current firm
        Jc=J(FProd,FProd);
        % Eigenvalues from SOC
        lambda=eig(Jc);
        
%         if sum(Resc)>1e-6
%             disp('FOC not satisfied for');
%             disp('firm: '); disp(f);
%             disp('in market: '); disp(m)
%         end
       
        if sum(lambda>0)>0
            disp('SOC not satisfied for');
            disp('firm: '); disp(f);
            disp('in market: '); disp(m)
        end
    end
end
