function combine_data(ParameterFileReg,ParameterFileEst,aggregate,AllDataFile)

global IDV IDF NV NF NP
global WANTWGT IDWGT WGT
global dsm dcs alt mar 
global DataDir 
global NTAKES NDRAWS NMEM DRAWTYPE
global DR MDR PUTDR

NPb=0;
NCSb=0;
NROWSb=0;

eval(ParameterFileReg);
for i=1:R
    flag=0;

    eval(['NROWS=NROWS',int2str(i),';']);

    eval(['BaseString=BaseString',int2str(i),';']);
%    eval(['OutString=OutString',int2str(i),';']);
    
    eval(ParameterFileEst);
    
    %Load data
    XMAT=load(fullfile(DataDir,[BaseString,'_data.raw']));  
    
    %Create variable identifying run and add to end of XMAT
    RUN=zeros(NROWS,1);
    eval(['RUN(:)=',int2str(i),';']);
    XMATc=[XMAT RUN];
    run=size(XMATc,2);  
    
    %Aggregate data to market level if appropriate
    if aggregate==1
        %If data contains no weights, add column of ones to end of data
        if WANTWGT==0
            WANTWGT=1;
            flag=1;         %Denote that final column contains weights
            W=ones(NROWS,1);
            XMATc=[XMATc W];
            IDWGT=size(XMATc,2);
        end
        [XMATc,NP,NCS,NROWS]=collapsedata(XMATc,run,Factor);
    elseif aggregate==0
        eval(['NP=NP',int2str(i),';']);
        eval(['NCS=NCS',int2str(i),';']);
        eval(['NROWS=NROWS',int2str(i),';']);
    end
    
    %Create vector of weights (no longer normalised to necessarily sum to
    %NP)
    cp=XMATc(:,dsm); % person
    if WANTWGT==1||WANTWGT==2;
        WGT=zeros(1,NP);
        for r=1:NP
            WGT(1,r)=sum(XMATc(cp == r,IDWGT),1);
        end
        WGT=WGT./max(XMAT(:,alt));
    else
        WGT=ones(1,NP);
    end    
    
    %If previously added, remove final column of weights
    if flag==1
        XMATc=XMATc(:,1:(size(XMATc,2)-1));
    end
    
    %Adjust choice situation and decision maker indices
    XMATc(:,dcs)=XMATc(:,dcs)+NCSb;
    XMATc(:,dsm)=XMATc(:,dsm)+NPb;

    %Rename data
    eval(['XMAT',int2str(i),'=XMATc;']);
    eval(['WGT',int2str(i),'=WGT;']);

    eval(['NP',int2str(i),'=NP;']);
    eval(['NCS',int2str(i),'=NCS;']);
    eval(['NROWS',int2str(i),'=NROWS;']);
    
    %Update dimension variables
    NPb=NPb+NP;
    NCSb=NCSb+NCS;
    NROWSb=NROWSb+NROWS;
    
    clear XMAT
end

%Dimensions of combined data
NP=NPb;
NCS=NCSb;
NROWS=NROWSb;

run=size(XMAT1,2);

%Matrices for combined data
XMAT=zeros(NROWS,run);
WGT=zeros(1,NP);

%Loop round groups and append together data
NROWSc=0;
NPc=0;
for i=1:R
    eval(['XMAT(1+NROWSc:NROWS',int2str(i),'+NROWSc,:)=XMAT',int2str(i),';']);
    eval(['NROWSc=NROWSc+NROWS',int2str(i),';']);
    eval(['WGT(1,1+NPc:NP',int2str(i),'+NPc)=WGT',int2str(i),';']);
    eval(['NPc=NPc+NP',int2str(i),';']);
end

if aggregate==1
    WGT=reshape(WGT,[max(XMAT(:,mar)) R]);
    WGT=WGT.*R./repmat(sum(WGT,2),[1 R]);
    WGT=reshape(WGT,[max(XMAT(:,mar))*R 1])';
end

% if aggregate==0
%     NMEM=20;
% end

NTAKES=NDRAWS./NMEM;

randn('state',SEED1)  %For draws from normal
rand('state',SEED1)   %For draws from uniform

%Create draws

PUTDR=fullfile(OutDir,'computationdraws');
if DRAWTYPE ~= 5
   disp('Creating draws.');
   DR=makedraws;   %NMEMxNPxNV matrix of draws
   if NTAKES == 1
      DR=permute(DR,[3,2,1]);   %To make NVxNPxNDRAWS
   else
%       PUTDRe=fullfile(OutDir,'computationdraws');
%       MDR=memmapfile(PUTDRe,'Format',{'double',[NDRAWS,NP,NV],'drs'});
      MDR=memmapfile(PUTDR,'Format',{'double',[NDRAWS,NP,NV],'drs'});
   end
end

TALT=max(XMAT(:,alt));

[NCSMAX,S,Market,Group]=IMatrix(TALT,NP,XMAT);

%Save new data
save(AllDataFile,'XMAT','WGT','NP','NCS','NROWS','NTAKES','DR','MDR','TALT', ...
    'NCSMAX','S','Market','Group');
