% Input b has dimension NVx1. 
% Input w has dimension NVx1.
% Input dr are the draws and have dimension NV x NP x NMEM  
% Output der has dimension NVxNPxNMEM.
% Uses IDV to determine transformations of draws in dr.

function [db, dw]=der(b,w,dr)
 
global IDV NV NP NMEM corrc

db=ones(NV,NP,NMEM);

if sum(IDV(:,2) == 2 | IDV(:,2) == 3 | IDV(:,2) == 4) >0

    if NV>0
     if corrc==1
       L=zeros(NV,NV);
       x=0;
       for i=1:NV
           for j=1:i
             L(i,j)=w(x+1);
             x=x+1;
           end
       end
  
       eta=zeros(NV,NP,NMEM);
       for p=1:NP
          for m=1:NMEM
              eta(:,p,m)=L*squeeze(dr(:,p,m));
          end
       end
      elseif corrc==0
          eta=repmat(w,[1,NP,NMEM]).*dr;
      end
      c=repmat(b,[1,NP,NMEM])+eta;                %Create NVxNPxNMEM matrix of b+w*dr
    end

   db(IDV(:,2) == 2,:,:)=exp(c(IDV(:,2) == 2,:,:)); %Transform log normal 

   db(IDV(:,2) == 3,:,:)=(c(IDV(:,2) == 3,:,:)>0); %Tranform truncated normal

   db(IDV(:,2) == 4,:,:)=exp(c(IDV(:,2) == 4,:,:))./(1+exp(c(IDV(:,2) == 4,:,:)));
   db(IDV(:,2) == 4,:,:)=db(IDV(:,2)==4,:,:) - (db(IDV(:,2)==4,:,:).^2); %Transform logistic
  
end;

if corrc==1
    dw=zeros(0.5*NV*(NV+1),NP,NMEM);
    x=0;
    for i=1:NV
        for j=1:i
          dw(x+1,:,:)=db(i,:,:).*dr(j,:,:);
          x=x+1;
        end
    end
    
elseif corrc==0
    dw=db.*dr; 
end




