function [delas]=diselas(GradS,p,var,XMAT,TALT,elas,DElasOut,S,aggregate)

global NP NCSMAX asymmetry
global dsm dcs alt mar 

cp=XMAT(:,dsm);
CS=XMAT(:,dcs);
OPS=XMAT(:,alt);

if elas==0

     delas = GradS;          %NAM(j)xNAM(i)xNCSxNP matrix of elasticities
     
elseif elas==1

    Xp=zeros(TALT,NCSMAX,NP);    %Matrix for price variable

    for n=1:NP;  %loop over people
        PP=var(cp==n);  %Selects prices for household
  
        cs=CS(cp == n);    %Selects choice situations for hh
        t1=cs(1,1);    %First choice situation
        t2=cs(end,1);  %Final choice situation
  
        if asymmetry==0 %Runs more quickly with identical choice sets
        
            for t=t1:t2; %loop over choice situations
                k=sum(cs==t); %Number of alts 
                Xp(1:k,1+t-t1,n)=PP(cs==t);
            end
  
        else
            ops=OPS(cp == n);    %Selects options for hh
            for t=t1:t2; %loop over choice situations
                cops=ops(cs==t);
                r1=cops(1,1);
                r2=cops(end,1);
                for r=r1:r2 %loop over options
                    if sum(cops==r)==1 %skip options not in choice set
                        Xp(r,1+t-t1,n)=PP(cs==t & ops==r);
                    end
                end
            end         
        end
    end

    Xp=repmat(Xp,[1 1 1 TALT]);
    Xp=permute(Xp,[1 4 2 3]);     %TALTxTALTxNCSxNP matrix of price

    p=repmat(p,[1 1 1 TALT]);
    p=permute(p,[4 1 2 3]);       %TALTxTALTxNCSxNP matrix of probabilities

    delas = GradS.*Xp./p;         %TALTxTALTxNCSxNP matrix of elasticities
    delas(isnan(delas))=0;        %Replace elasticities for non-existant alts
                                  %and choice situs to zeros
elseif elas==2
    
    p=repmat(p,[1 1 1 TALT]);
    p=permute(p,[4 1 2 3]);       %TALTxTALTxNCSxNP matrix of probabilities

    delas = GradS./p;             %TALTxTALTxNCSxNP matrix of elasticities
    delas(isnan(delas))=0;        %Replace elasticities for non-existant alts
    
end

%TEMPORARY EXPEDIENT
own=zeros(NP*NCSMAX*TALT,1);
i = 1;
for p=1:NP
    for c=1:NCSMAX
        temp=diag(delas(:,:,c,p));
        own(1+TALT*(i-1):i*TALT,1)=temp;
        i=i+1;
    end
end

S=reshape(S,NP*NCSMAX*TALT,1); %NP*NCSMAX*NAMx1

if aggregate==1
    Elasdata=[XMAT(:,size(XMAT,2)) XMAT(:,mar) XMAT(:,alt) own(S==1)];
elseif aggregate==0
    Elasdata=[XMAT(:,dsm) XMAT(:,dcs) XMAT(:,size(XMAT,2)) XMAT(:,mar) ...
        XMAT(:,alt) own(S==1)];
end
    
    save(DElasOut,'Elasdata','-ascii','-double','-tabs'); 
