function finitead_dis(BrandCode,OBrand,Brd,TALT,Market,nMarket,XMAT,OScf,SV,SVI, ...
    SV2,SVI2,AllCoefFile,R,Group,AdFiniteOut,Price)

global NP NCSMAX NCS WGT DR MDR S 
global PV PVI IDV dcs

nBrand=max(BrandCode);
Agg=zeros(nBrand,TALT,nMarket);
Els=zeros(nBrand,TALT,nMarket);
NROWS=size(XMAT,1);

bindex=(1:nBrand)';

NO=length(OBrand);
for i=1:NO
    bindex=bindex(bindex~=OBrand(i));
end

nInBrand=length(bindex);

for bb=1:nInBrand

    b=bindex(bb);
    
    VX=XMAT(:,SV);
    %VX(Brd==b)=log(OScf(Brd==b)+1);
    VX(Brd==b)=log(OScf(Brd==b)+((OScf(Brd==b)).^2+1).^0.5);
    
    %Update XMAT data to include average prices
    [XMATX]=updatedata(XMAT,VX,SV,SVI);

    %Actual own advertising for brand b
    VC=zeros(NROWS,1);
    %Counterfactual own advertising for brand b
    VN=zeros(NROWS,1);
    for i=1:NCS
        if sum(XMAT(:,dcs)==i & Brd==b)>0
            x=mean(XMAT(XMAT(:,dcs)==i & Brd==b,SV));
            %VC(XMAT(:,dcs)==i)=exp(x)-1;
            VC(XMAT(:,dcs)==i)=0.5*(exp(x)-exp(-x));
            x=mean(OScf(XMAT(:,dcs)==i & Brd==b));
            VN(XMAT(:,dcs)==i)=x;
        end
    end
    VC(Brd==b)=0;
    VN(Brd==b)=0;
    for i=1:NO
        VC(Brd==OBrand(i))=0;
        VN(Brd==OBrand(i))=0;
    end
    
    %VX=exp(XMAT(:,SV2))-1;
    VX=0.5*(exp(XMAT(:,SV2))-exp(-XMAT(:,SV2)));
    VX=VX-VC+VN;
    %VX=log(VX+1);
    VX=log(VX+(VX.^2+1).^0.5);
    
    %Update XMAT data to include average prices
    [XMATX]=updatedata(XMATX,VX,SV2,SVI2);

    [X, XF]=simulationdata(NP,NCSMAX,XMATX,TALT);

    %Compute market shares at disaggregate level
    [p, pp]=marketshare(AllCoefFile,X,XF,NP,NCSMAX,TALT,DR,MDR,R,Group,S); 

    %Compute market shares at market level
    [aggshare]=aggregatemarketshare(p,TALT,Market,nMarket,WGT);
    
    %Compute gradient of utility wrt price
    [Gradv]=indexgrad(XMATX,AllCoefFile,NP,NCSMAX,TALT,DR,MDR,PV,PVI,R,Group);

    %Reverse sign of utility gradient if random coefficient is log normal
    if isempty(IDV)==0
     if sum(IDV(1,:)==PV)>0
        if IDV(find(IDV(1,:)==PV),2)==2
            Gradv=-Gradv;
        end
     end
    end
    %Compute price elasticities
    %  Set elas = 0 for derivatives
    %  Set elas = 1 for elasticities
    %  Set elas = 2 for semi-elasticities
    elas=1;
    [PGradS,GradM]=sharederiv(Gradv,pp,Market,TALT);
    [melas]=marketelas(p,PGradS,GradM,TALT,Price,Market,nMarket,[],WGT,elas);

    Agg(b,:,:)=aggshare;
    for m=1:nMarket
        Els(b,:,m)=diag(melas(:,:,m));
    end
end

Agg=reshape(Agg,[nBrand*TALT*nMarket 1]); %nMarket *TALTxnBrand
Els=reshape(Els,[nBrand*TALT*nMarket 1]); %nMarket *TALTxnBrand

Mk=(1:nMarket)';
Mk=kron(Mk,ones(nBrand*TALT,1));

Op=(1:TALT)';
OptionShare=repmat(kron(Op,ones(nBrand,1)),nMarket,1);

varop=(1:nBrand)';
OptionAd=repmat(varop,nMarket*TALT,1);

Data=[Mk OptionShare OptionAd Agg Els];
save(AdFiniteOut,'Data','-ascii','-double','-tabs');
