function [XMATc,Sc,Groupc,DRc,MDRc,NPc,NCSMAXc,WGTc]= ...
    marketdata(NTAKES,DR,MDR,TALT,XMAT,WGT,NP,NCS,Index)

    global NV 
    global NDRAWS
    global dsm dcs alt asymmetry

    % Collect data for current market
    XMATc=XMAT(Index,:);
    
    %Select random draws for households present in current market
    dsindex=zeros(NP,1); %Vector to indicate decision makers inclusion in
                         %market
    for i=1:NP
        dsindex(i)=max(XMATc(:,dsm)==i);
    end
    
    if NTAKES==1
        DRc=DR(:,dsindex==1,:); %Select draws for dms in market
        MDRc=[];                
        
    elseif NTAKES > 1
        DR=MDR.Data(1).drs(:,:,:);  %Exctract all draws from saved file
        DRc=DR(:,dsindex==1,:);     %Keep only draws for dms in market
        NPc=size(DRc,2);
        DRc=reshape(DRc,[NDRAWS,NPc*NV]);
        
        fid=fopen('drawscurrent','w');
        fwrite(fid,DRc,'double');
        fclose(fid);
        
        DRc=[];
        MDRc=memmapfile('drawscurrent','Format',{'double',[NDRAWS,NPc,NV],'drs'});
    end
    
    % Renumber market decision makers and choice situations
    % (CODE CURRENTLY ASSUMES ALL OPTIONS ARE PRESENT IN EACH MARKET)
    Pc=XMATc(:,dsm);       %Original decision maker index
    Pc2=zeros(size(Pc));   %Vector for market decision maker index
    i=0;
    for k=1:NP
        i2=sum(Pc==k)>0;
        i=i+i2;
        Pc2(Pc==k)=i;
    end
    XMATc(:,dsm)=Pc2;
    NPc=max(XMATc(:,dsm));
    
    Pc=XMATc(:,dcs);       %Original choice situation index
    Pc2=zeros(size(Pc));   %Vector for market choice situation index
    i=0;
    for k=1:NCS
        i2=sum(Pc==k)>0;
        i=i+i2;
        Pc2(Pc==k)=i;
    end
    XMATc(:,dcs)=Pc2;
    clear Pc2
    
    [NCSMAXc,Sc,Marketc,Groupc]=IMatrix(TALT,NPc,XMATc);

    %Weights for households present in market
    WGTc=ones(1,NPc);
    i=1;
    for j=1:NP
        if sum(Pc==j)>0
            WGTc(i)=WGT(j);
            i=i+1;
        end
    end
    WGTc=WGTc./sum(WGTc);
    clear Pc 
