function [R,J]=simulationfun(FreePrice,XMAT,S,Group,DR,MDR,NP,NCSMAX,iPrice,Price,...
    AllCoefFile,R,AllFirmsProducts,AllCompetitorProducts,costs,PriceSim,TALT,IDV,WGT,...
    type,Factor)

global alt PV PVI CC1 CC2 OProd OFirm

NROWS=size(XMAT,1);

Price(iPrice)=FreePrice;  %Update price vector

ops=XMAT(:,alt);        %Vector of alternative indexes
PSIM=zeros(NROWS,1);     %Vector to hold prices for all choice situations
for k=1:TALT
    PSIM(ops==k)=Price(k);
end

if PriceSim==1
    if type==1
        PSIM(XMAT(:,alt)~=OProd)=CC1+CC2*PSIM(XMAT(:,alt)~=OProd);   
    elseif type==2
        PSIM(XMAT(:,alt)~=OProd)=CC1*XMAT(XMAT(:,alt)~=OProd,Factor) ...
            +PSIM(XMAT(:,alt)~=OProd);   
    elseif type==3
        PSIM(XMAT(:,alt)~=OProd)=(1+CC2*XMAT(XMAT(:,alt)~=OProd,Factor)).* ...
            PSIM(XMAT(:,alt)~=OProd);   
    end
end
%Reverse sign of price if price random coefficient is log normal
if sum(IDV(1,:)==PV)>0
    if IDV(find(IDV(1,:)==PV),2)==2
        PSIM=-PSIM;
    end
end

[uXMAT]=updatedata(XMAT,PSIM,PV,PVI);

%Construct data matrices
[X XF]=simulationdata(NP,NCSMAX,uXMAT,TALT);

[Share,GradS,FGradS,Hess]=SimulationMatrix(uXMAT,NP,NCSMAX,X,XF,DR,MDR,S,Group,...
    AllCoefFile,R,AllFirmsProducts,AllCompetitorProducts,TALT,IDV);

%TALTxTALTxTALT matrix of margins (varying over 3rd dimension)
margins=reshape(repmat((Price-costs)',[TALT*TALT 1])...
    ,[TALT TALT TALT]);

%TALTxTALTxTALTxNCSMAXxNP matrix of summed up Hessian
Weight=permute(repmat(WGT', [1 TALT TALT TALT NCSMAX]),[2 3 4 5 1]);

%TALTxTALTxTALT matrix of summed up Hessian
SHess=sum(sum(Hess.*Weight,4),5);

%TALTxTALT - one element is
%sum_iinF d2s_i/dp_jdp_k*(p_i-c_i)
temp=sum(margins.*SHess,3);

%TALTxTALTxNCSMAXxNP matrix of summed up Hessian
Weight=permute(repmat(WGT', [1 TALT TALT NCSMAX]),[2 3 4 1]);

%TALTx1 vector of market shares
MShare=sum(sum(Share.*permute(repmat(WGT',[1 TALT NCSMAX]),[2 3 1]),2),3);

%TALTx1 vector of FOC residuals
R=MShare+sum(sum(GradS.*Weight,3),4)*(Price-costs);
R=R(iPrice);

%NALTMAXxNALTMAX Jacobian for FOCS
J=sum(sum(FGradS.*Weight,3),4)'+sum(sum(GradS.*Weight,3),4)+temp;
J=J(iPrice,iPrice);