function testloglik(param)

dx = 1e-4;
[l adl] = loglik(param); %Calculate analytical gradient at x0 
K=length(param);
ndl = zeros(K,1);    %Set size of numerical gradient vector
 
%loop through elements of x0 and calculate numerical gradient
for i = 1:K
    x1 = param;                 %Reset x1
    x2 = param;                 %Reset x2
    x1(i) = param(i)+dx;        %Change one element by a small amount    
    x2(i) = 2*param(i)-x1(i);   %Change one element by a small amount
    l1 = loglik(x1);            %Likelihood at x1
    l2 = loglik(x2);            %Likelihood at x2
    ndl(i) = (l1-l2)/(x1(i)-x2(i));   %Numerical gradient
    
    disp('Index Coefficient   Analytical  Numerical   Difference')
    disp([i param(i) adl(i) ndl(i) abs(adl(i)-ndl(i))]);
end
