function [W,ww]=welfare(AllCoefFile,X,XF,NP,NCSMAX,TALT,DR,MDR,R,Group,S) 

global NV NF NDRAWS NMEM NTAKES
%global IDV IDF PV

load(AllCoefFile);

W=zeros(NCSMAX,NP); %NCSMAXxNP

for r=1:NTAKES   %NTAKES is the number of draws that are are read into memory at one time                              

if NTAKES>1
   DR=MDR.Data(1).drs((r-1).*NMEM+1:r.*NMEM,:,:); %Dimensions: NMEM x NP x NV
   DR=permute(DR,[3,2,1]); %To make NV x NP x NMEM
end

Group=repmat(Group,[1,1,1,NMEM]);

v=zeros(TALT,NCSMAX,NP,NMEM);
for i=1:R

 c=trans(bhat(:,i),what(:,i),DR,NP);   %c is NVxNPxNMEM matrix of b+w*dr (possibly transformed)
 if NF > 0
    ff=reshape(fhat(:,i),1,1,NF,1);  %1x1xNFx1 matrix of fixed coeffs
    ff=repmat(ff,[TALT,NCSMAX,1,NP]); %NAMxNCSMxNFxNP matrix of fixed coeffs
    vf=reshape(sum(XF.*ff,3),TALT,NCSMAX,NP);  %NAMxNCSMxNP matrix of f*FX
 else
    vf=zeros(TALT,NCSMAX,NP);
 end
 vf=repmat(vf,[1,1,1,NMEM]); %NAMxNCSMxNPxNMEM matrix of f*FX

 if NV >0
   
    cc=reshape(c,1,1,NV,NP,NMEM); %1x1xNVxNPxNMEM matrix of b+w*dr
    cc=repmat(cc,[TALT,NCSMAX,1,1,1]); %NAMxNCSMxNVxNPxNMEM matrix of b+w*dr
    vr=(repmat(X,[1,1,1,1,NMEM]).*cc); %NAMxNCSMxNVxNPxNMEM matrix of (b+w*dr).*RX
    vr=reshape(sum(vr,3),TALT,NCSMAX,NP,NMEM); %NAMxNCSMxNPxNMEM matrix of (b+w*dr)*RX
    v(Group==i)=vr(Group==i)+vf(Group==i); %NAMxNCSMxNPxNMEM matrix of f*FX+(b+w*dr)*RX
 else
    v(Group==i)=vf(Group==i);
 end

end

v=exp(v);  %NAMxNCSMxNPxNMEM matrix of exp(f*FX+(b+w*dr)*RX)
v(isinf(v))=10.^20;  %As precaution when exp(v) is too large for machine
v=v.*repmat(S,[1,1,1,NMEM]);  %Set exp(v) to zero for non-options/CS
V=sum(v,1);
w=zeros(NCSMAX,NP,NMEM);
w(:,:,:)=V(1,:,:,:);           %NCSMAXxNPxNMEM

ww=log(w);
sw=sum(ww,3);                   %NCSMAXxNP 

W=W+sw;

if NTAKES>1
    eval(['ww',int2str(r),'=ww;']);
end

end

if NTAKES>1
    ww=zeros(TALT,NCSMAX,NP,NDRAWS);
    for r=1:NTAKES
        eval(['ww(:,:,:,1+(r-1)*NMEM:NMEM+(r-1)*NMEM)=ww',int2str(r),';']);
    end
end
W=W./NDRAWS; %NCSMAXxNP 