

***********************
*** definition of weeks
***********************

u "M:\TNS\extractedfiles\index_files\dates_detail.dta",clear
drop date
gen long date=year*10000+month*100+dayofmonth
drop yearweek demyear dayofweek weekday dayofmonth
drop if year<2009
egen group = group(week)
sort date
bysort week: gen temp = month if _n==4
egen temp2 = min(temp),by(week)
replace month = temp2
drop temp temp2
bysort week: gen temp = year if _n==4
egen temp2 = min(temp),by(week)
replace year = temp2
drop temp temp2
drop week
rename group week
sa "$PA\week_ad.dta",replace


****************************
**manipulate Nielsen advertising data
****************************
u "M:/Advertising/Disaggregate/Data/Confectionery_Snacks_2009.dta",clear
append using "M:/Advertising/Disaggregate/Data/Confectionery_Snacks_2010.dta"

gen     agg_brand = 1  if regexm(brand,"Pringles")==1
replace agg_brand = 2  if regexm(brand,"Walkers Crisps")==1|regexm(brand,"Walkers - Crisps")
replace agg_brand = 3  if regexm(brand,"Walkers Sensation")|regexm(brand,"Walkers - Sensations")==1
replace agg_brand = 4  if regexm(brand,"Walkers - Doritos")==1
replace agg_brand = 5  if regexm(brand,"Walkers - Baked")==1 | regexm(brand,"Walkers - Extra")==1 | regexm(brand,"Walkers - Red")==1
replace agg_brand = 6  if regexm(brand,"Kp")==1
replace agg_brand = 7  if regexm(brand,"Golden Wonder")==1
replace agg_brand = 8  if regexm(brand,"Asda - Crisps Rge")==1
replace agg_brand = 10 if regexm(brand,"Kettle Chips")==1|regexm(brand,"Mini Cheddars")==1|regexm(brand,"Phileas Fogg")
lab def agg_brand 1 "Pringles" 2 "Walkers Regular" 3 "Walkers Sensations" 4 "Walkers Doritos" 5 "Walkers Other" 6 "KP" 7 "GW" 8 "Asda" 9 "Tesco" 10 "Other"
lab val agg_brand type
drop if agg_brand==.

merge m:1 date using "$PA\week_ad.dta"
keep if _m==3
drop _m

gen temp = lower(channel)
drop if regexm(temp,"ulster")==1

gen drop = 0
gen     station = "ITV1"     if (regexm(temp,"itv ")==1|regexm(temp,"itv1 ")==1|regexm(temp,"itv")==1|regexm(temp,"itvmacro")==1)&(regexm(temp,"2")==0&regexm(temp,"3")==0&regexm(temp,"4")==0)
replace station = "C4"       if regexm(temp,"c4 -")==1|regexm(temp,"c4macro")==1
replace drop = 1 if station!="C4"& regexm(temp,"c4")==1
replace station = "C4"       if regexm(temp,"s4")==1
replace station = "C5"       if regexm(temp,"c5")==1|regexm(temp,"c5macro")==1

replace station = "ITV2" if temp=="astra - itv2"|temp=="astra - itv2 hd"
replace drop = 1 if station!="ITV2"& regexm(temp,"itv2")==1
replace station = "ITV3" if temp=="astra - itv3"|temp=="astra - itv3 hd"
replace drop = 1 if station!="ITV3"& regexm(temp,"itv3")==1
replace station = "ITV4" if temp=="astra - itv 4"|temp=="astra - itv 4 hd"
replace drop = 1 if station!="ITV4"& regexm(temp,"itv 4")==1
replace station = "FiveUSA"    if temp=="astra - five usa"|temp=="astra - 5 usa"
replace drop = 1 if station=="" & (regexm(temp,"five usa")==1|regexm(temp,"astra - 5 usa")==1)
replace station = "Fiver"      if temp=="astra - 5*"|temp=="astra - fiver"
replace drop = 1 if station=="" & (regexm(temp,"astra - 5")==1|regexm(temp,"astra - fiver")==1)
replace station = "Challenge"  if regexm(temp,"challenge tv")==1
replace drop = 1 if station!="Challenge" & regexm(temp,"challenge")==1
replace station = "E4"         if temp=="astra - e4"
replace drop = 1 if station!="E4" & regexm(temp,"e4")==1
replace station = "Film4"         if temp=="astra - film4"
replace drop = 1 if station!="Film4" & regexm(temp,"film4")==1
replace station = "More4"         if temp=="astra - more 4"
replace drop = 1 if station!="More4" & regexm(temp,"more 4")==1
replace station = "Dave"       if regexm(temp,"uktv dave")==1
replace drop = 1 if regexm(temp,"dave ja vu")==1
replace station = "Sky3"       if temp=="astra - sky 3"
replace drop = 1 if station!="Sky3" & regexm(temp,"sky 3")==1
replace station = "SkyNews"    if regexm(temp,"sky news")==1
replace station = "Really"     if regexm(temp,"really")==1
replace station = "Yesterday"  if temp=="astra - yesterday"
replace drop = 1 if station!="Yesterday" & regexm(temp,"yesterday")==1

replace station = "RemainFreeview" if regexm(temp,"4music")==1|temp=="astra - quest"|regexm(temp,"cbs action")==1|temp=="astra - cbs reality"|temp=="astra - food network"|regexm(temp,"pick")==1|regexm(temp,"the travel channel")==1|regexm(temp,"viva")==1
replace drop = 1 if station!="RemainFreeview" & (regexm(temp,"quest")==1|regexm(temp,"cbs reality")==1|regexm(temp,"travel channel")==1|regexm(temp,"food network")==1)

replace station = "Alibi"  if temp=="astra - alibi"
replace drop = 1 if station=="" & regexm(temp,"alibi")==1
replace station = "AnimalPlanet"  if temp=="astra - animal planet"
replace drop = 1 if station=="" & regexm(temp,"animal planet")==1
replace station = "Biography"        if regexm(temp,"bio")==1
replace station = "Blighty"        if regexm(temp,"blighty")==1
replace station = "Box"        if regexm(temp,"the box")==1
replace station = "Bravo"      if temp=="astra - bravo"|temp=="astra - bravo 2"
replace drop = 1 if station=="" & regexm(temp,"bravo")==1
replace station = "ComedyC"    if temp=="astra - comedy central"|temp=="astra - comedy central extra"
replace drop = 1 if station=="" &  regexm(temp,"comedy")==1 & regexm(temp,"1")==1
replace station = "Crime"       if regexm(temp,"astra - crime")==1 & regexm(temp,"1")==0
replace drop = 1 if station=="" & regexm(temp,"astra - crime")==1
replace station = "Discovery"        if temp=="astra - discovery"|temp=="astra - discovery hd"
replace station = "DiscoveryHist"    if temp=="astra - discovery history"
replace station = "DiscoveryHome"    if temp=="astra - discovery home & health"
replace station = "DiscoveryReal"    if temp=="astra - discovery real time"|temp=="astra - discovery shed"
replace drop = 1 if station=="" & regexm(temp,"discovery")==1 & regexm(temp,"1")==1
replace station = "Eden"              if temp=="astra - eden"
replace drop = 1 if station=="" & regexm(temp,"eden")==1
replace station = "FX"                 if temp=="astra - fx"
replace drop = 1  if station=="" & regexm(temp,"fx")==1
replace station = "GOLD"                 if (regexm(temp,"g.o.l.d")==1|regexm(temp,"gold")==1)&regexm(temp,"1")==0
replace drop = 1  if station=="" & (regexm(temp,"g.o.l.d")==1|regexm(temp,"gold")==1)
replace station = "Living"                 if regexm(temp,"astra - living")==1&regexm(temp,"1")==0
replace station = "Living2"      if regexm(temp,"astra - living")==1&regexm(temp,"2")==1
replace drop = 1 if station=="" & regexm(temp,"astra - living")==1&regexm(temp,"1")==1
replace station = "MTV"                 if regexm(temp,"mtv")==1 & regexm(temp,"1")==0
replace drop = 1 if station=="" & regexm(temp,"mtv")==1 & regexm(temp,"1")==1
replace station = "Sky1"                 if regexm(temp,"sky 1")==1
replace station = "Sky2"                 if regexm(temp,"sky 2")==1
replace station = "SkyMovies"              if regexm(temp,"sky movies")==1& regexm(temp,"1")==0
replace drop = 1 if station==""  & regexm(temp,"sky movies")==1& regexm(temp,"1")==1
replace station = "SkyBoxOf"              if regexm(temp,"sky box office")==1
replace station = "SkySports"              if regexm(temp,"sky sports")==1& regexm(temp,"news")==0
replace station = "SkySportsN"              if regexm(temp,"sky sports news")==1
replace station = "SkyRealLiv"            if regexm(temp,"real lives")==1&regexm(temp,"1")==0
replace drop = 1 if station==""  & regexm(temp,"real lives")==1&regexm(temp,"1")==1
replace station = "Watch"            if regexm(temp,"watch")==1 & regexm(temp,"1")==0
replace drop = 1 if station==""  &    regexm(temp,"watch")==1
replace station = "UKTVFood"             if regexm(temp,"good food")==1& regexm(temp,"1")==0
replace drop = 1 if station==""  & regexm(temp,"good food")==1
replace station = "Home"                 if regexm(temp,"astra - home")==1 & regexm(temp,"1")==0
replace drop = 1 if station==""  & regexm(temp,"astra - home")==1
replace station = "NationalG"                 if (regexm(temp,"national geographic")==1|regexm(temp,"nat geo")==1)& regexm(temp,"1")==0
replace drop = 1 if station==""  & regexm(temp,"national geographic")==1
replace station = "Trouble"               if regexm(temp,"trouble")==1
replace station = "VH1"               if regexm(temp,"vh-1")==1
replace station = "History"            if regexm(temp,"- history")==1 & regexm(temp,"1")==0
replace drop = 1 if station=="" &  regexm(temp,"- history")==1

replace drop = 1 if station=="" & drop==0 & regexm(temp,"1")==1
replace station = "RemainPay" if station=="" & drop==0

gen     region = "Scotland"    if regexm(temp,"scotland")==1|regexm(temp,"border")==1
replace region = "North_East"  if regexm(temp,"tyne tees")==1|regexm(temp,"north east")==1
replace region = "North_West"  if regexm(temp,"granada")==1|regexm(temp,"north west")==1|regexm(temp,"c4macro - north")==1|regexm(temp,"c5macro - north")==1
replace region = "Yorkshire"   if regexm(temp,"yorkshire")==1
replace region = "Wales"       if regexm(temp,"wales")==1|station=="S4"
replace region = "Midlands"    if (regexm(temp,"central")==1|regexm(temp,"midlands")==1)&regexm(temp,"comedy")==0
replace region = "East_Anglia" if regexm(temp,"anglia")==1|regexm(temp,"east of england")==1|regexm(temp,"c5 - east")==1
replace region = "South_West"  if regexm(temp,"westcountry")==1|regexm(temp,"south west")==1|regexm(temp,"hd - westc")==1
replace region = "West"        if regexm(temp,"htv west")==1|regexm(temp,"htv west")==1|regexm(temp,"breakfast - west")==1|regexm(temp,"midwest")==1|regexm(temp,"macro - west")==1|regexm(temp,"t hd - west")==1|regexm(temp,"c4 - west")==1
replace region = "South_East"  if region==""&(regexm(temp,"meridian")==1|regexm(temp,"sth,sth east & chan")==1|regexm(temp,"sth,sth e & chan")==1|regexm(temp,"south england")==1|regexm(temp,"south east")==1)|regexm(temp,"c4macro - south")==1
replace region = "London"      if regexm(temp,"carlton")==1|regexm(temp,"london")==1
replace region = "National"    if region==""

gen     slot = "Week0600_0930" if day<6 &               time< 93001
replace slot = "Week0930_1200" if day<6 & time> 93000 & time<120001
replace slot = "Week1200_1400" if day<6 & time>120000 & time<140001
replace slot = "Week1400_1600" if day<6 & time>140000 & time<160001
replace slot = "Week1600_1800" if day<6 & time>160000 & time<180001
replace slot = "Week1800_2000" if day<6 & time>180000 & time<200001
replace slot = "Week2000_2230" if day<6 & time>200000 & time<223001
replace slot = "Week2230_0100" if day<6 & time>223000 & time<250001
replace slot = "Week0100_0600" if day<6 & time>250000
replace slot = "Sat0600_0930" if day==6 &               time< 93001
replace slot = "Sat0930_1200" if day==6 & time> 93000 & time<120001
replace slot = "Sat1200_1400" if day==6 & time>120000 & time<140001
replace slot = "Sat1400_1600" if day==6 & time>140000 & time<160001
replace slot = "Sat1600_1800" if day==6 & time>160000 & time<180001
replace slot = "Sat1800_2000" if day==6 & time>180000 & time<200001
replace slot = "Sat2000_2230" if day==6 & time>200000 & time<223001
replace slot = "Sat2230_0100" if day==6 & time>223000 & time<250001
replace slot = "Sat0100_0600" if day==6 & time>250000
replace slot = "Sun0600_0930" if day==7 &               time< 93001
replace slot = "Sun0930_1200" if day==7 & time> 93000 & time<120001
replace slot = "Sun1200_1400" if day==7 & time>120000 & time<140001
replace slot = "Sun1400_1600" if day==7 & time>140000 & time<160001
replace slot = "Sun1600_1800" if day==7 & time>160000 & time<180001
replace slot = "Sun1800_2000" if day==7 & time>180000 & time<200001
replace slot = "Sun2000_2230" if day==7 & time>200000 & time<223001
replace slot = "Sun2230_0100" if day==7 & time>223000 & time<250001
replace slot = "Sun0100_0600" if day==7 & time>250000

drop if drop==1
drop if station=="RemainFreeview"|station=="RemainPay"

gen show1=trim(prior)
gen show2=trim(after) if trim(prior)~=trim(after)

forval i=1(1)2 {
   replace show`i'="Chris Moyles Quiz Show" if show`i'=="Chris Moyles Quiz Sh"
   replace show`i'="Dickinson's Real Deal" if show`i'=="Dickinson's Real Dea"
   replace show`i'="Film" if substr(show`i',1,4)=="Film"
   replace show`i'="Relocation Relocation" if show`i'=="Relocation Relocati"
   replace show`i'="The Alan Titchmarsh Show" if show`i'=="The Alan Titchmarsh"
   replace show`i'="Big Bang Theory" if show`i'=="The Big Bang Theory"
   replace show`i'="Henry Viii Mind Of A Tyrant" if show`i'=="Henry Viii: Mind Of"
   replace show`i'="I Own Britain's Best Home" if show`i'=="I Own Britain's Best"
   replace show`i'="I'm Running Sainsbury's" if show`i'=="I'M Running Sainsbur"
   replace show`i'="New You've Been Framed" if show`i'=="New You've Been Fram"
   replace show`i'="Piers Morgan's Life Stories" if show`i'=="Piers Morgan's Life"
   replace show`i'="Ramsay's Kitchen Nightmares" if show`i'=="Ramsay's Kitchen Nig"
   replace show`i'="Law & Order" if substr(show`i',1,11)=="Law & Order"
   replace show`i'="GMTV" if regexm(lower(show`i'),"gmtv")==1
   replace show`i'="Britain's Got Talent" if regexm(lower(show`i'),"britain")==1&regexm(lower(show`i'),"talent")==1
   replace show`i' = "CSI" if substr(show`i',1,7)=="Csi: Cr"
   replace show`i' = "CSI: New York" if show`i'=="Csi: Ny"|show`i'=="Csi: New York"
   replace show`i' = "CSI: Miami" if show`i'=="Csi: Miami"|show`i'=="Csi Miami"
   replace show`i' = "Law & Order" if regexm(lower(show`i'),"law")==1&regexm(lower(show`i'),"order")==1
   replace show`i' = "Uefa Champions League" if regexm(lower(show`i'),"champions")==1&regexm(lower(show`i'),"league")==1
   replace show`i'="Everybody Hates Chris" if show`i'=="Everybody Hates Chri"
   replace show`i'="Extreme Fishing" if substr(show`i',1,15)=="Extreme Fishing"
}

sa "$PA/RGadverts_detail.dta",replace
*keep agg_brand expenditure length ym week station slot region show1 show2
keep agg_brand expenditure length week station slot region show1 show2
compress
sa "$PA/RGadverts.dta",replace



****************************
**manipulate Kantar media data on shows
****************************
u  "M:\TNS\extractedfiles\media_data\hhmedia2009.dta",clear
keep hhno v_2875-v_3086
merge m:1 hhno using "$P/hh_active.dta"
keep if _m==3
drop _m

gen show2="ITV1 This Morning" if -v_2880<-2
gen show3="ITV1 The Jeremy Kyle Show" if -v_2879<-2
gen show6="ITV1 Coronation Street" if -v_2889<-2|-v_2912<-2
gen show12="ITV1 Gmtv" if -v_2875<-2|-v_2876<-2|-v_2877<-2|-v_2878<-2|- v_2901<-2|-v_2910<-2
gen show16="ITV1 Loose Women" if -v_2881<-2
gen show17="ITV1 ITV Lunchtime News" if -v_2882<-2
gen show18="ITV1 Dickinson's Real Deal" if -v_2883<-2
gen show19="ITV1 The Alan Titchmarsh Show" if -v_2884<-2
gen show21="ITV1 A Touch Of Frost" if -v_2885<-2
gen show22="ITV1 Taste The Nation" if - v_2886<-2
gen show23="ITV1 ITV Evening News" if -v_2887<-2
gen show24="ITV1 Emmerdale" if -v_2888<-2
gen show25="ITV1 UEFA Champions League" if -v_2890<-2
gen show26="ITV1 The Bill" if -v_2891<-2
gen show27="ITV1 Tonight" if -v_2893<-2
gen show28="ITV1 Law & Order" if -v_2894<-2
gen show29="ITV1 Trinny And Susannah" if -v_2895<-2
gen show31="ITV1 Moving Wallpaper" if -v_2896<-2
gen show32="ITV1 Superhuman" if -v_2897<-2
gen show33="ITV1 Pushing Daisies" if - v_2898<-2
gen show34="ITV1 Cops With Cameras" if -v_2899<-2
gen show35="ITV1 Dexter" if -v_2900<-2
gen show37="ITV1 Citv" if - v_2902<-2|-v_2913<-2
gen show38="ITV1 Harry Hill's Tv Burp" if - v_2903<-2
gen show39="ITV1 New You've Been Framed" if -v_2904<-2
gen show41="ITV1 Britain's Got Talent" if -v_2905<-2
gen show42="ITV1 Primeval" if -v_2906<-2
gen show43="ITV1 The Colour Of Money" if -v_2907<-2
gen show44="ITV1 The Fa Cup" if -v_2908<-2
gen show45="ITV1 Midsomer Murders" if -v_2909<-2
gen show47="ITV1 The Championship" if -v_2911<-2
gen show51="ITV1 Dog Rescue" if -v_2915<-2
gen show52="ITV1 Heartbeat" if -v_2916<-2
gen show53="ITV1 He Kills Coppers" if -v_2917<-2
gen show54="ITV1 Piers Morgan's Life Stories" if -v_2918<-2
gen show55="ITV1 Lewis" if -v_2919<-2
gen show56="ITV1 The South Bank Show" if -v_2920<-2

gen show1="C4 Hollyoaks" if -v_2932<-2|-v_2957<-2
gen show4="C4 Come Dine With Me" if -v_2945<-2
gen show5="C4 Frasier" if -v_2925<-2
gen show11="C4 Scrubs" if -v_2956<-2
gen show57="C4 The Hoobs" if -v_2921<-2
gen show58="C4 Freshly Squeezed" if -v_2922<-2
gen show59="C4 Everybody Loves Raymond" if -v_2923<-2
gen show61="C4 Will And Grace" if -v_2924<-2
gen show62="C4 Coach Trip" if -v_2926<-2
gen show63="C4 A Place In The Sun" if -v_2927<-2
gen show64="C4 Countdown" if -v_2928<-2
gen show65="C4 Deal Or No Deal" if -v_2929<-2
gen show66="C4 The Paul O'Grady Show" if -v_2930<-2
gen show67="C4 The Simpsons" if -v_2931<-2
gen show68="C4 Channel 4 News" if -v_2933<-2
gen show69="C4 Unreported World" if -v_2934<-2
gen show71="C4 Ramsay's Kitchen Nightmares" if -v_2935<-2
gen show72="C4 Grand Designs" if -v_2936<-2
gen show73="C4 Relocation Relocation" if -v_2937<-2
gen show74="C4 ER" if -v_2938<-2
gen show75="C4 Embarrassing Bodies" if -v_2939<-2
gen show76="C4 Desperate Housewives" if -v_2940<-2
gen show77="C4 Henry Viii Mind Of A Tyrant" if -v_2941<-2
gen show78="C4 The Home Show" if -v_2942<-2
gen show79="C4 Extreme Male Beauty" if -v_2943<-2
gen show81="C4 Big Bang Theory" if -v_2944<-2
gen show82="C4 Around The World in 80 Trades" if -v_2946<-2
gen show83="C4 I'm Running Sainsbury's" if -v_2947<-2
gen show84="C4 Skins" if -v_2948<-2
gen show85="C4 Shameless" if -v_2949<-2
gen show86="C4 Peep Show" if -v_2950<-2
gen show87="C4 Born To Be Different" if -v_2951<-2
gen show88="C4 Gok's Fashion Fix" if -v_2952<-2
gen show89="C4 The Morning Line" if - v_2953<-2
gen show91="C4 Channel 4 Racing" if -v_2954<-2
gen show92="C4 Come Dine With Me" if -v_2955<-2
gen show94="C4 Chris Moyles Quiz Show" if -v_2958<-2
gen show95="C4 Shipwrecked" if -v_2959<-2
gen show96="C4 Scrapheap Challenge" if -v_2960<-2
gen show97="C4 Come Dine With Me" if -v_2961<-2
gen show98="C4 Secret Millionaire" if -v_2962<-2
gen show99="C4 The Big Art Project" if -v_2963<-2
gen show101="C4 Supernanny Usa" if -v_2964<-2

gen show102="BBC1 Breakfast" if -v_2965<-2
gen show103="BBC1 Homes Under The Hammer" if -v_2966<-2
gen show104="BBC1 To Buy or Not to Buy" if -v_2967<-2
gen show105="BBC1 Cash in the Attic" if -v_2968<-2
gen show106="BBC1 Bargain Hunt" if -v_2969<-2
gen show107="BBC1 BBC One O'Clock News" if -v_2970<-2
gen show108="BBC1 Doctors" if -v_2971<-2
gen show109="BBC1 Diagnosis Murder" if -v_2972<-2
gen show111="BBC1 CBBC" if -v_2973<-2
gen show112="BBC1 The Weakest Link" if -v_2974<-2
gen show113="BBC1 BBC Six O'Clock News" if -v_3007<-2
gen show114="BBC1 The ONE Show" if -v_3008<-2
gen show115="BBC1 Eastenders" if -v_3009<-2|-v_3032<-2
gen show116="BBC1 Holby City" if -v_3010<-2
gen show117="BBC1 A Question Of Sport" if -v_3011<-2
gen show118="BBC1 Panorama" if -v_3012<-2
gen show119="BBC1 Waterloo Road" if -v_3013<-2
gen show121="BBC1 The Apprentice" if -v_3014<-2
gen show122="BBC1 Have I Got News For You" if -v_3015<-2
gen show123="BBC1 My Family" if -v_3016<-2
gen show124="BBC1 Crimewatch" if -v_3017<-2
gen show125="BBC1 Damages" if -v_3018<-2|-v_3035<-2
gen show126="BBC1 The Real Swiss Family Robinson" if -v_3019<-2
gen show127="BBC1 BBC Ten O'Clock News" if -v_3020<-2
gen show128="BBC1 Question Time" if -v_3021<-2
gen show129="BBC1 Friday Night With Jonathan Ross" if -v_3022<-2
gen show131="BBC1 Saturday Kitchen" if -v_3023<-2
gen show132="BBC1 Casualty" if -v_3025<-2
gen show133="BBC1 Robin Hood" if -v_3026<-2
gen show134="BBC1 Total Wipeout" if -v_3027<-2
gen show135="BBC1 The National Lottery: 1 vs 100" if -v_3028<-2
gen show136="BBC1 Match Of The Day" if -v_3029<-2|-v_3052<-2
gen show137="BBC1 The Andrew Marr Show" if -v_3030<-2
gen show138="BBC1 Antiques Roadshow" if -v_3031<-2
gen show142="BBC1 Formula One Live" if -v_3138<-2
gen show143="BBC1 Songs Of Praise" if -v_3033<-2
gen show144="BBC1 The No.1 Ladies' Detective Agency" if -v_3034<-2
gen show145="BBC2 Heros" if -v_3036<-2
gen show146="BBC2 Escape to the Country" if -v_3037<-2
gen show147="BBC2 Nigella Express" if -v_3038<-2
gen show148="BBC2 Gardeners World" if -v_3039<-2
gen show149="BBC2 Alan Whickers" if -v_3040<-2
gen show151="BBC2 Journey of a Lifetime" if -v_3041<-2
gen show152="BBC2 The Apprentice: You're Fired!" if -v_3042<-2
gen show153="BBC2 QI" if -v_3043<-2
gen show154="BBC2 Later With Jools Holland" if -v_3044<-2
gen show155="BBC2 Newsnight" if -v_3045<-2
gen show156="BBC2 The Wire" if -v_3046<-2
gen show157="BBC2 Natural World" if -v_3047<-2
gen show158="BBC2 Planet Earth" if - v_3048<-2
gen show159="BBC2 Timewatch" if -v_3049<-2
gen show161="BBC2 Top Gear" if -v_3050<-2
gen show162="BBC2 Five Minutes of Heaven" if -v_3051<-2

gen show7="C5 Neighbours" if -v_322<-2|-v_3053<-2
gen show9="C5 Csi" if -v_3066<-2
gen show164="C5 Milkshake" if -v_315<-2
gen show165="C5 Thomas & Friends" if -v_316<-2
gen show166="C5 Roary The Racing Car" if -v_317<-2
gen show167="C5 Make Way For Noddy" if -v_318<-2
gen show168="C5 The Wright Stuff" if -v_319<-2
gen show169="C5 Trisha Goddard" if -v_320<-2
gen show171="C5 Monkey Life" if -v_384<-2
gen show172="C5 Home And Away" if -v_321<-2|-v_3054<-2
gen show173="C5 Afternoon Film" if -v_323<-2
gen show174="C5 Five News" if -v_324<-2|-v_3055<-2
gen show177="C5 Mobil 1 The Grid" if -v_3056<-2
gen show178="C5 Massive Speed" if -v_3057<-2
gen show179="C5 Extreme Fishing" if -v_3058<-2
gen show181="C5 The Gadget Show" if -v_3059<-2
gen show182="C5 Oil Riggers" if -v_3060<-2
gen show183="C5 Extraordinary People" if -v_3061<-2
gen show184="C5 Numbers" if -v_3062<-2
gen show185="C5 I Own Britain's Best Home" if -v_3063<-2
gen show186="C5 Ncis" if -v_3064<-2
gen show187="C5 The Mentalist" if -v_3065<-2
gen show188="C5 CSI: Miami" if -v_3067<-2
gen show189="C5 Film" if -v_3068<-2
gen show191="C5 Law & Order" if -v_3069<-2|-v_3070<-2|-v_3075<-2|-v_3079<-2
gen show193="C5 Roobarb & Custard" if -v_3071<-2
gen show194="C5 The Gadget Show" if -v_3072<-2
gen show195="C5 Mobil 1 The Grid" if -v_3073<-2
gen show196="C5 Afternoon Film On 5" if -v_3074<-2
gen show198="C5 Saturday Family Movie On 5" if -v_3076<-2
gen show199="C5 Ncis" if -v_3077<-2
gen show201="C5 Csi: New York" if -v_3078<-2
gen show203="C5 Harry & His Bucketful Of Dinosaurs" if -v_3080<-2
gen show204="C5 Sunday Afternoon Films" if -v_3081<-2
gen show205="C5 Everybody Hates Chris" if -v_3082<-2
gen show206="C5 Sunday Family Movie On Five" if -v_3083<-2
gen show207="C5 Sunday 9pm Movie" if -v_3084<-2
gen show208="C5 Latenight Sport" if -v_3085<-2
gen show209="C5 Numbers" if -v_3086<-2

keep hhno show*
reshape long show,j(n) i(hhno)
drop n
gen station=word(show,1)
drop if show==""|station==""

ren show temp
gen     show = substr(temp,4,length(temp)) if substr(temp,1,1)=="C"
replace show = substr(temp,6,length(temp)) if substr(temp,1,1)=="B"|substr(temp,1,1)=="I"

drop temp
replace show=trim(show)
sa "$PA/RGhh_shows_detail.dta",replace
drop if station=="BBC1"|station=="BBC2"
compress
contract hhno station show
drop _freq
so hhno station show
sa "$PA/RGhh_shows.dta",replace



*************************************************************************
** create prob view the "ircd" (i:hhno, r:region, c:station, d:day(slot)) level
*************************************************************************

u  "M:\TNS\extractedfiles\media_data\hhmedia2009.dta",clear
merge m:1 hhno using "$P/hh_active.dta",keep(match)
drop _m
gen slot1="Week0600_0930" if -v_3<-2
gen slot2="Week0930_1200" if -v_4<-2
gen slot3="Week1200_1400" if -v_5<-2
gen slot4="Week1400_1600" if -v_6<-2
gen slot5="Week1600_1800" if -v_7<-2
gen slot6="Week1800_2000" if -v_8<-2
gen slot7="Week2000_2230" if -v_9<-2
gen slot8="Week2230_0100" if -v_10<-2
gen slot9="Week0100_0600" if -v_11<-2
gen slot10="Sat0600_0930" if -v_121<-2
gen slot11="Sat0930_1200" if -v_122<-2
gen slot12="Sat1200_1400" if -v_123<-2
gen slot13="Sat1400_1600" if -v_124<-2
gen slot14="Sat1600_1800" if -v_125<-2
gen slot15="Sat1800_2000" if -v_126<-2
gen slot16="Sat2000_2230" if -v_127<-2
gen slot17="Sat2230_0100" if -v_128<-2
gen slot18="Sat0100_0600" if -v_129<-2
gen slot19="Sun0600_0930" if -v_130<-2
gen slot20="Sun0930_1200" if -v_131<-2
gen slot21="Sun1200_1400" if -v_132<-2
gen slot22="Sun1400_1600" if -v_133<-2
gen slot23="Sun1600_1800" if -v_134<-2
gen slot24="Sun1800_2000" if -v_135<-2
gen slot25="Sun2000_2230" if -v_136<-2
gen slot26="Sun2230_0100" if -v_137<-2
gen slot27="Sun0100_0600" if -v_138<-2
keep hhno slot*
reshape long slot,j(n) i(hhno)
drop n
drop if slot==""
compress
contract hhno slot
drop _freq
so hhno slot
sa "$PA/RGhh_slot.dta",replace

*Households in media data
u "$PA/RGhh_slot.dta",clear
keep hhno
bysort hhno: keep if _n==1
sa "$PA/hh_in_media.dta",replace

** main shopper general tv viewing habits from Kantar main questionnaire
u "M:\TNS\extractedfiles\panel_data\hhpanel_all.dta",clear
keep hhno demyear tvreg cable satellite ntvs freeview itvchannel_1 tv_days tv_hours tv_comm
merge m:1 hhno using "$P/hh_active.dta"
drop if _m==1
drop _m
merge m:1 hhno using "$PA/hh_in_media.dta"
keep if _m==3
drop _m
sort hhno demyear
foreach v in cable sat freeview tv_days {
    by hhno: replace `v'=`v'[_n-1] if `v'==9
}
foreach v in ntvs tv_hours tv_comm {
    by hhno: replace `v'=`v'[_n-1] if `v'==99
}
by hhno: replace itvchannel_1=itvchannel_1[_n-1] if itvchannel_1==0
keep if demyear==2009|demyear==2010
sort hhno demyear
by hhno: keep if _n==1
gen     region = "Scotland"    if tvreg==7
replace region = "North_East"  if tvreg==3
replace region = "North_West"  if tvreg==5
replace region = "Yorkshire"   if tvreg==4
replace region = "Wales"       if tvreg==9 & itvchannel==12
replace region = "Midlands"    if tvreg==2
replace region = "East_Anglia" if tvreg==8
replace region = "South_West"  if tvreg==10
replace region = "West"        if tvreg==9 & itvchannel!=12
replace region = "South_East"  if tvreg==6
replace region = "London"      if tvreg==1
drop demyear
sa "$PA/RGhh_panel_tv.dta",replace
keep hhno region
drop if region==""
compress
so hhno region
sa "$PA/RGhh_region.dta",replace



** main shopper specific station viewing habits from Kantar media data
u  "M:\TNS\extractedfiles\media_data\hhmedia2009.dta",clear
merge m:1 hhno using "$P/hh_active.dta",keep(match)
drop _m

gen station1="BBC1" if -v_115<-2
gen station2="BBC2" if -v_116<-2
gen station3="ITV1" if -v_117<-2
gen station4="C4" if -v_118<-2
gen station5="C5" if -v_119<-2
gen station6="Sky1" if -v_440<-2
gen station7="Sky2" if -v_441<-2
gen station8="Sky3" if -v_442<-2
gen station9="SkyNews" if -v_443<-2
gen station10="SkyMovies" if -v_444<-2
gen station11="SkyBoxOf" if -v_445<-2
gen station12="SkySports" if -v_446<-2|-v_447<-2|-v_448<-2
gen station13="SkyRealLiv" if -v_449<-2
gen station14="ITV2" if -v_451<-2
gen station15="ITV3" if -v_452<-2
gen station16="ITV4" if -v_453<-2
gen station17="CITV" if -v_454<-2
gen station18="Film4" if -v_455<-2
gen station19="E4" if -v_456<-2
gen station20="More4" if -v_457<-2
gen station21="BBC3" if -v_458<-2
gen station22="BBC4" if -v_459<-2
gen station23="BBCNews" if -v_460<-2
gen station24="CBBC" if -v_461<-2
gen station25="CBeebies" if -v_462<-2
gen station26="Eden" if -v_3087<-2
gen station27="Alibi" if -v_3088<-2
gen station28="Watch" if -v_3089<-2
gen station29="UKTVFood" if -v_3090<-2
gen station30="Really" if -v_3091<-2
gen station31="GOLD" if -v_3092<-2
gen station32="Dave" if -v_3093<-2
gen station33="Yesterday" if -v_3094<-2
gen station34="Blighty" if -v_3095<-2
gen station35="Home" if -v_3096<-2
gen station36="AnimalPlanet" if -v_2154<-2
gen station37="Biography" if -v_494<-2
gen station38="Bravo" if -v_496<-2
gen station39="CartoonN" if -v_497<-2
gen station40="Challenge" if -v_498<-2
gen station41="Crime" if -v_499<-2
gen station42="Discovery" if -v_500<-2
gen station43="DiscoveryHist" if -v_501<-2
gen station44="DiscoveryHome" if -v_502<-2
gen station45="DiscoveryReal" if -v_503<-2
gen station46="Disney" if -v_504<-2
gen station47="Eurosport" if -v_505<-2
gen station48="Fiver" if -v_545<-2
gen station49="FiveUSA" if -v_546<-2
gen station50="FX" if -v_547<-2
gen station51="Hallmark" if -v_548<-2
gen station52="Playhouse" if -v_549<-2
gen station53="Living" if -v_550<-2
gen station54="Living2" if -v_551<-2
gen station55="MTV" if -v_553<-2
gen station56="NationalG" if -v_554<-2
gen station57="Nickelodeon" if -v_555<-2
gen station58="ComedyC" if -v_556<-2
gen station59="Scifi" if -v_557<-2
gen station60="Box" if -v_574<-2
gen station61="History" if -v_575<-2
gen station62="TMF" if -v_577<-2
gen station63="Trouble" if -v_578<-2
gen station64="VH1" if -v_579<-2
gen station65="Virgin" if -v_580<-2
keep hhno station*
reshape long station,j(n) i(hhno)
drop n
drop if station==""
compress
contract hhno station
drop _freq
so hhno station
sa "$PA/RGhh_station.dta",replace




***********************************
** create a hhno index to loop over
***********************************
u "$PA/RGhh_shows.dta",clear
contract hhno
drop _freq
so hhno
sa "$PA/RGtemp.dta",replace
u "$PA/RGhh_region.dta",clear
contract hhno
drop _freq
mer 1:1 hhno using "$PA/RGtemp.dta"
drop _m
sa "$PA/RGtemp.dta",replace
u "$PA/RGhh_slot.dta",clear
contract hhno
drop _freq
mer 1:1 hhno using "$PA/RGtemp.dta"
drop _m
sa "$P/RGtemp.dta",replace
u "$P/RGhh_station.dta",clear
contract hhno
drop _freq
mer 1:1 hhno using "$P/RGtemp.dta"
drop _m
egen hhidx=group(hhno)
so hhidx
sa "$PA/RGhhidx.dta",replace

u "$PA/RGhhidx.dta",clear
su hhidx
local hh=r(max)
forval i=1(1)`hh' {
   u "$PA/RGadverts.dta",clear
   gen hhidx=`i'
   * get hhno
   so hhidx
   mer m:1 hhidx using "$PA/RGhhidx.dta",keep(match)
   drop _m
   * match in shows that hh watch regularly
   ren show1 show
   so hhno station show
   mer m:1 hhno station show using "$PA/RGhh_shows.dta",keep(master match)
   gen w_show =_m==3
   drop _m
   ren show show1
   ren show2 show
   so hhno station show
   mer m:1 hhno station show using "$PA/RGhh_shows.dta",keep(master match)
   replace w_show=1 if _m==3
   drop _m
   ren show show2
   * merge in tv region that hh lives in
   so hhno region
   mer m:1 hhno region using "$PA/RGhh_region.dta",keep(master match)
   gen w_region =_m==3
   drop _m
   * merge in slots that hh regularly watches
   so hhno slot
   mer m:1 hhno slot using "$PA/RGhh_slot.dta",keep(master match)
   gen w_slot =_m==3
   drop _m
   * merge in stations that hh regularly watches
   so hhno station
   mer m:1 hhno station using "$PA/RGhh_station.dta",keep(master match)
   gen w_station =_m==3
   drop _m
   gen     w_rss = w_slot*w_station
   replace w_rss = w_region*w_slot*w_station if station=="ITV1"|station=="C4"|station=="C5"
   gen     w=w_show
   replace w=w_rss if w==0
   foreach v in w w_show w_rss {
      gen `v'exp = `v'*expenditure
      gen `v'length = `v'*length
      gen `v'ads = `v'
   }
   collapse (sum) wexp wlength wads w_showexp w_showlength w_showads w_rssexp w_rsslength w_rssads,by(hhidx hhno agg_brand week)
   compress
   if `i'>1 append using "$PA/RGhh_ads.dta"
   sa "$PA/RGhh_ads.dta",replace
}

***Add in households that don't watch TV
u  "M:\TNS\extractedfiles\media_data\hhmedia2009.dta",clear
keep hhno
merge 1:1 hhno using "$P/hh_active.dta"
keep if _m==3
drop _m
merge 1:m hhno using "$PA/RGhhidx.dta",keepusing(hhno)
keep if _m==1
drop _m
egen hhidx = group(hhno)
replace hhidx = hhidx + 2467
sa "$PA/RGhhidx_zv.dta",replace

u "$PA/RGhhidx_zv.dta",clear
su hhidx
local hhx=r(min)
local hh=r(max)
forval i=`hhx'(1)`hh' {
   u "$PA/RGadverts.dta",clear
   gen hhidx=`i'
   * get hhno
   so hhidx
   mer m:1 hhidx using "$PA/RGhhidx_zv.dta",keep(match)
   drop _m
   gen w_slot=0
   gen w_station=0
   gen w_region=0
   gen w_show=0
   gen     w_rss = w_slot*w_station
   replace w_rss = w_region*w_slot*w_station if station=="ITV1"|station=="C4"|station=="C5"
   gen     w=w_show
   replace w=w_rss if w==0
   foreach v in w w_show w_rss {
      gen `v'exp = `v'*expenditure
      gen `v'length = `v'*length
      gen `v'ads = `v'
   }
   collapse (sum) wexp wlength wads w_showexp w_showlength w_showads w_rssexp w_rsslength w_rssads,by(hhidx hhno agg_brand week)
   compress
   if `i'>`hhx' append using "$PA/RGhh_ads_zv.dta"
   sa "$PA/RGhh_ads_zv.dta",replace
}

u "$PA/RGhh_ads.dta",clear
append using "$PA/RGhh_ads_zv.dta"
sa "$PA/RGhh_ads.dta",replace

u "$PA\week_ad.dta",clear

bysort week: keep if _n==1

drop date

sa "$PA\week_temp.dta",replace

clear
set obs 105
gen week = _n
gen agg_brand = 9

merge 1:m week agg_brand using "$PA/RGhh_ads.dta"
foreach v in wexp wlength wads w_showexp w_showlength w_showads w_rssexp w_rsslength w_rssads {
    replace `v' = 0 if _m==1
}
replace hhid = 1 if _m==1
replace hhno = 10118 if _m==1
drop _m

merge m:1 week using "$PA\week_temp.dta"
keep if _m==3
drop _m

fillin hhid week agg_brand
drop _f

foreach v in year month {
    egen temp = min(`v'),by(week)
    replace `v' = temp if `v'==.
    drop temp
}
drop if week<6

egen temp = min(hhno),by(hhid)
replace hhno = temp if hhno==.
drop temp t

sort hhid agg_brand week
by hhid agg_brand: gen N = _N
by hhid agg_brand: gen n = _n

foreach v in wexp wlength wads w_showexp w_showlength w_showads w_rssexp w_rsslength w_rssads {

 replace `v' = 0 if `v'==.
 rename `v' of_`v'

 egen rf_`v' = sum(of_`v'),by(hhid week)
 replace rf_`v' = rf_`v'-of_`v'

 sort hhid agg_brand week

 gen os_`v' = 0
 gen rs_`v' = 0

 su N
 local l = r(mean)-1

 foreach x of numlist 0(1)`l' {

    gen NN = N-n-`x'
    gen     temp1 = of_`v'*(0.9^NN)
    replace temp1 = . if NN<0
    egen    temp2 = sum(temp1),by(hhid agg_brand)
    replace os_`v' = temp2 if NN==0
    drop temp1 temp2
    gen     temp1 = rf_`v'*(0.9^NN)
    replace temp1 = . if NN<0
    egen    temp2 = sum(temp1),by(hhid agg_brand)
    replace rs_`v' = temp2 if NN==0
    drop NN temp1 temp2
 }
}
drop n N

sa "$PA/RGdisagg_ad_stocks_ft.dta",replace

keep if week>21
drop if week>95
replace week = week - 21

sa "$PA/RGdisagg_ad_stocks.dta",replace
