clear
set more off
cap log close

global Path "C:/DuboisGriffithOConnell.2017.ReStud"
global P    "$Path\Stata_files\Estimation"
global PA   "$Path\Stata_files\Advertising"
global PI   "$Path\Stata_files\Instrument"

log using "$P2/create_inst.log",replace

****************************
**manipulate Nielsen advertising data
****************************

u "M:/Advertising/Disaggregate/Data/Confectionery_Snacks_2009.dta",clear
append using "M:/Advertising/Disaggregate/Data/Confectionery_Snacks_2010.dta"

merge m:1 date using "$PA\week_ad.dta"
keep if _m==3
drop _m

gen temp = lower(channel)
drop if regexm(temp,"ulster")==1

gen drop = 0
gen     station = "ITV1"     if (regexm(temp,"itv ")==1|regexm(temp,"itv1 ")==1|regexm(temp,"itv")==1|regexm(temp,"itvmacro")==1)&(regexm(temp,"2")==0&regexm(temp,"3")==0&regexm(temp,"4")==0)
replace station = "C4"       if regexm(temp,"c4 -")==1|regexm(temp,"c4macro")==1
replace drop = 1 if station!="C4"& regexm(temp,"c4")==1
replace station = "C4"       if regexm(temp,"s4")==1
replace station = "C5"       if regexm(temp,"c5")==1|regexm(temp,"c5macro")==1

replace station = "ITV2" if temp=="astra - itv2"|temp=="astra - itv2 hd"
replace drop = 1 if station!="ITV2"& regexm(temp,"itv2")==1
replace station = "ITV3" if temp=="astra - itv3"|temp=="astra - itv3 hd"
replace drop = 1 if station!="ITV3"& regexm(temp,"itv3")==1
replace station = "ITV4" if temp=="astra - itv 4"|temp=="astra - itv 4 hd"
replace drop = 1 if station!="ITV4"& regexm(temp,"itv 4")==1
replace station = "FiveUSA"    if temp=="astra - five usa"|temp=="astra - 5 usa"
replace drop = 1 if station=="" & (regexm(temp,"five usa")==1|regexm(temp,"astra - 5 usa")==1)
replace station = "Fiver"      if temp=="astra - 5*"|temp=="astra - fiver"
replace drop = 1 if station=="" & (regexm(temp,"astra - 5")==1|regexm(temp,"astra - fiver")==1)
replace station = "Challenge"  if regexm(temp,"challenge tv")==1
replace drop = 1 if station!="Challenge" & regexm(temp,"challenge")==1
replace station = "E4"         if temp=="astra - e4"
replace drop = 1 if station!="E4" & regexm(temp,"e4")==1
replace station = "Film4"         if temp=="astra - film4"
replace drop = 1 if station!="Film4" & regexm(temp,"film4")==1
replace station = "More4"         if temp=="astra - more 4"
replace drop = 1 if station!="More4" & regexm(temp,"more 4")==1
replace station = "Dave"       if regexm(temp,"uktv dave")==1
replace drop = 1 if regexm(temp,"dave ja vu")==1
replace station = "Sky3"       if temp=="astra - sky 3"
replace drop = 1 if station!="Sky3" & regexm(temp,"sky 3")==1
replace station = "SkyNews"    if regexm(temp,"sky news")==1
replace station = "Really"     if regexm(temp,"really")==1
replace station = "Yesterday"  if temp=="astra - yesterday"
replace drop = 1 if station!="Yesterday" & regexm(temp,"yesterday")==1

replace station = "RemainFreeview" if regexm(temp,"4music")==1|temp=="astra - quest"|regexm(temp,"cbs action")==1|temp=="astra - cbs reality"|temp=="astra - food network"|regexm(temp,"pick")==1|regexm(temp,"the travel channel")==1|regexm(temp,"viva")==1
replace drop = 1 if station!="RemainFreeview" & (regexm(temp,"quest")==1|regexm(temp,"cbs reality")==1|regexm(temp,"travel channel")==1|regexm(temp,"food network")==1)

replace station = "Alibi"  if temp=="astra - alibi"
replace drop = 1 if station=="" & regexm(temp,"alibi")==1
replace station = "AnimalPlanet"  if temp=="astra - animal planet"
replace drop = 1 if station=="" & regexm(temp,"animal planet")==1
replace station = "Biography"        if regexm(temp,"bio")==1
replace station = "Blighty"        if regexm(temp,"blighty")==1
replace station = "Box"        if regexm(temp,"the box")==1
replace station = "Bravo"      if temp=="astra - bravo"|temp=="astra - bravo 2"
replace drop = 1 if station=="" & regexm(temp,"bravo")==1
replace station = "ComedyC"    if temp=="astra - comedy central"|temp=="astra - comedy central extra"
replace drop = 1 if station=="" &  regexm(temp,"comedy")==1 & regexm(temp,"1")==1
replace station = "Crime"       if regexm(temp,"astra - crime")==1 & regexm(temp,"1")==0
replace drop = 1 if station=="" & regexm(temp,"astra - crime")==1
replace station = "Discovery"        if temp=="astra - discovery"|temp=="astra - discovery hd"
replace station = "DiscoveryHist"    if temp=="astra - discovery history"
replace station = "DiscoveryHome"    if temp=="astra - discovery home & health"
replace station = "DiscoveryReal"    if temp=="astra - discovery real time"|temp=="astra - discovery shed"
replace drop = 1 if station=="" & regexm(temp,"discovery")==1 & regexm(temp,"1")==1
replace station = "Eden"              if temp=="astra - eden"
replace drop = 1 if station=="" & regexm(temp,"eden")==1
replace station = "FX"                 if temp=="astra - fx"
replace drop = 1  if station=="" & regexm(temp,"fx")==1
replace station = "GOLD"                 if (regexm(temp,"g.o.l.d")==1|regexm(temp,"gold")==1)&regexm(temp,"1")==0
replace drop = 1  if station=="" & (regexm(temp,"g.o.l.d")==1|regexm(temp,"gold")==1)
replace station = "Living"                 if regexm(temp,"astra - living")==1&regexm(temp,"1")==0
replace station = "Living2"      if regexm(temp,"astra - living")==1&regexm(temp,"2")==1
replace drop = 1 if station=="" & regexm(temp,"astra - living")==1&regexm(temp,"1")==1
replace station = "MTV"                 if regexm(temp,"mtv")==1 & regexm(temp,"1")==0
replace drop = 1 if station=="" & regexm(temp,"mtv")==1 & regexm(temp,"1")==1
replace station = "Sky1"                 if regexm(temp,"sky 1")==1
replace station = "Sky2"                 if regexm(temp,"sky 2")==1
replace station = "SkyMovies"              if regexm(temp,"sky movies")==1& regexm(temp,"1")==0
replace drop = 1 if station==""  & regexm(temp,"sky movies")==1& regexm(temp,"1")==1
replace station = "SkyBoxOf"              if regexm(temp,"sky box office")==1
replace station = "SkySports"              if regexm(temp,"sky sports")==1& regexm(temp,"news")==0
replace station = "SkySportsN"              if regexm(temp,"sky sports news")==1
replace station = "SkyRealLiv"            if regexm(temp,"real lives")==1&regexm(temp,"1")==0
replace drop = 1 if station==""  & regexm(temp,"real lives")==1&regexm(temp,"1")==1
replace station = "Watch"            if regexm(temp,"watch")==1 & regexm(temp,"1")==0
replace drop = 1 if station==""  &    regexm(temp,"watch")==1
replace station = "UKTVFood"             if regexm(temp,"good food")==1& regexm(temp,"1")==0
replace drop = 1 if station==""  & regexm(temp,"good food")==1
replace station = "Home"                 if regexm(temp,"astra - home")==1 & regexm(temp,"1")==0
replace drop = 1 if station==""  & regexm(temp,"astra - home")==1
replace station = "NationalG"                 if (regexm(temp,"national geographic")==1|regexm(temp,"nat geo")==1)& regexm(temp,"1")==0
replace drop = 1 if station==""  & regexm(temp,"national geographic")==1
replace station = "Trouble"               if regexm(temp,"trouble")==1
replace station = "VH1"               if regexm(temp,"vh-1")==1
replace station = "History"            if regexm(temp,"- history")==1 & regexm(temp,"1")==0
replace drop = 1 if station=="" &  regexm(temp,"- history")==1

replace drop = 1 if station=="" & drop==0 & regexm(temp,"1")==1
replace station = "RemainPay" if station=="" & drop==0

gen     region = "Scotland"    if regexm(temp,"scotland")==1|regexm(temp,"border")==1
replace region = "North_East"  if regexm(temp,"tyne tees")==1|regexm(temp,"north east")==1
replace region = "North_West"  if regexm(temp,"granada")==1|regexm(temp,"north west")==1|regexm(temp,"c4macro - north")==1|regexm(temp,"c5macro - north")==1
replace region = "Yorkshire"   if regexm(temp,"yorkshire")==1
replace region = "Wales"       if regexm(temp,"wales")==1|station=="S4"
replace region = "Midlands"    if (regexm(temp,"central")==1|regexm(temp,"midlands")==1)&regexm(temp,"comedy")==0
replace region = "East_Anglia" if regexm(temp,"anglia")==1|regexm(temp,"east of england")==1|regexm(temp,"c5 - east")==1
replace region = "South_West"  if regexm(temp,"westcountry")==1|regexm(temp,"south west")==1|regexm(temp,"hd - westc")==1
replace region = "West"        if regexm(temp,"htv west")==1|regexm(temp,"htv west")==1|regexm(temp,"breakfast - west")==1|regexm(temp,"midwest")==1|regexm(temp,"macro - west")==1|regexm(temp,"t hd - west")==1|regexm(temp,"c4 - west")==1
replace region = "South_East"  if region==""&(regexm(temp,"meridian")==1|regexm(temp,"sth,sth east & chan")==1|regexm(temp,"sth,sth e & chan")==1|regexm(temp,"south england")==1|regexm(temp,"south east")==1)|regexm(temp,"c4macro - south")==1
replace region = "London"      if regexm(temp,"carlton")==1|regexm(temp,"london")==1
replace region = "National"    if region==""

gen     slot = "Week0600_0930" if day<6 &               time< 93001
replace slot = "Week0930_1200" if day<6 & time> 93000 & time<120001
replace slot = "Week1200_1400" if day<6 & time>120000 & time<140001
replace slot = "Week1400_1600" if day<6 & time>140000 & time<160001
replace slot = "Week1600_1800" if day<6 & time>160000 & time<180001
replace slot = "Week1800_2000" if day<6 & time>180000 & time<200001
replace slot = "Week2000_2230" if day<6 & time>200000 & time<223001
replace slot = "Week2230_0100" if day<6 & time>223000 & time<250001
replace slot = "Week0100_0600" if day<6 & time>250000
replace slot = "Sat0600_0930" if day==6 &               time< 93001
replace slot = "Sat0930_1200" if day==6 & time> 93000 & time<120001
replace slot = "Sat1200_1400" if day==6 & time>120000 & time<140001
replace slot = "Sat1400_1600" if day==6 & time>140000 & time<160001
replace slot = "Sat1600_1800" if day==6 & time>160000 & time<180001
replace slot = "Sat1800_2000" if day==6 & time>180000 & time<200001
replace slot = "Sat2000_2230" if day==6 & time>200000 & time<223001
replace slot = "Sat2230_0100" if day==6 & time>223000 & time<250001
replace slot = "Sat0100_0600" if day==6 & time>250000
replace slot = "Sun0600_0930" if day==7 &               time< 93001
replace slot = "Sun0930_1200" if day==7 & time> 93000 & time<120001
replace slot = "Sun1200_1400" if day==7 & time>120000 & time<140001
replace slot = "Sun1400_1600" if day==7 & time>140000 & time<160001
replace slot = "Sun1600_1800" if day==7 & time>160000 & time<180001
replace slot = "Sun1800_2000" if day==7 & time>180000 & time<200001
replace slot = "Sun2000_2230" if day==7 & time>200000 & time<223001
replace slot = "Sun2230_0100" if day==7 & time>223000 & time<250001
replace slot = "Sun0100_0600" if day==7 & time>250000

drop if drop==1
drop if station=="RemainFreeview"|station=="RemainPay"

gen show1=trim(prior)
gen show2=trim(after) if trim(prior)~=trim(after)

forval i=1(1)2 {
   replace show`i'="Chris Moyles Quiz Show" if show`i'=="Chris Moyles Quiz Sh"
   replace show`i'="Dickinson's Real Deal" if show`i'=="Dickinson's Real Dea"
   replace show`i'="Film" if substr(show`i',1,4)=="Film"
   replace show`i'="Relocation Relocation" if show`i'=="Relocation Relocati"
   replace show`i'="The Alan Titchmarsh Show" if show`i'=="The Alan Titchmarsh"
   replace show`i'="Big Bang Theory" if show`i'=="The Big Bang Theory"
   replace show`i'="Henry Viii Mind Of A Tyrant" if show`i'=="Henry Viii: Mind Of"
   replace show`i'="I Own Britain's Best Home" if show`i'=="I Own Britain's Best"
   replace show`i'="I'm Running Sainsbury's" if show`i'=="I'M Running Sainsbur"
   replace show`i'="New You've Been Framed" if show`i'=="New You've Been Fram"
   replace show`i'="Piers Morgan's Life Stories" if show`i'=="Piers Morgan's Life"
   replace show`i'="Ramsay's Kitchen Nightmares" if show`i'=="Ramsay's Kitchen Nig"
   replace show`i'="Law & Order" if substr(show`i',1,11)=="Law & Order"
   replace show`i'="GMTV" if regexm(lower(show`i'),"gmtv")==1
   replace show`i'="Britain's Got Talent" if regexm(lower(show`i'),"britain")==1&regexm(lower(show`i'),"talent")==1
   replace show`i' = "CSI" if substr(show`i',1,7)=="Csi: Cr"
   replace show`i' = "CSI: New York" if show`i'=="Csi: Ny"|show`i'=="Csi: New York"
   replace show`i' = "CSI: Miami" if show`i'=="Csi: Miami"|show`i'=="Csi Miami"
   replace show`i' = "Law & Order" if regexm(lower(show`i'),"law")==1&regexm(lower(show`i'),"order")==1
   replace show`i' = "Uefa Champions League" if regexm(lower(show`i'),"champions")==1&regexm(lower(show`i'),"league")==1
   replace show`i'="Everybody Hates Chris" if show`i'=="Everybody Hates Chri"
   replace show`i'="Extreme Fishing" if substr(show`i',1,15)=="Extreme Fishing"
}

sa "$PI/all_adverts_detail.dta",replace

u "$PI/all_adverts_detail.dta",clear

gen price = expenditure/length

keep if region=="National"

collapse (mean) price,by(slot station week year month)

fillin slot station week

foreach v in year month {
    egen temp = min(`v'),by(week)
    replace `v' = temp if `v'==.
    drop temp
}

egen temp = mean(price),by(slot station year month)
replace price = temp if price==.
drop temp

gen     day = 1 if regexm(slot,"Week")==1
replace day = 2 if regexm(slot,"Sat")==1
replace day = 3 if regexm(slot,"Sun")==1

gen     time = 1 if regexm(slot,"0100_0600")==1
replace time = 2 if regexm(slot,"0600_0930")==1
replace time = 3 if regexm(slot,"0930_1200")==1
replace time = 4 if regexm(slot,"1200_1400")==1
replace time = 5 if regexm(slot,"1400_1600")==1
replace time = 6 if regexm(slot,"1600_1800")==1
replace time = 7 if regexm(slot,"1800_2000")==1
replace time = 8 if regexm(slot,"2000_2230")==1
replace time = 9 if regexm(slot,"2230_0100")==1

egen temp = mean(price),by(time station year month)
replace price = temp if price==.
drop temp

egen temp = mean(price),by(time station year)
replace price = temp if price==.
drop temp

egen temp = mean(price),by(time station)
replace price = temp if price==.
drop temp

egen temp = mean(price),by(station)
replace price = temp if price==.
drop temp

keep year month week station slot price

gen region="National"

sa "$PI/price_national.dta",replace

u "$PI/all_adverts_detail.dta",clear

gen price = expenditure/length

keep if region!="National"

collapse (mean) price,by(region slot station week year month)

fillin region slot station week

foreach v in year month {
    egen temp = min(`v'),by(week)
    replace `v' = temp if `v'==.
    drop temp
}

egen temp = mean(price),by(slot region station year month)
replace price = temp if price==.
drop temp

gen     day = 1 if regexm(slot,"Week")==1
replace day = 2 if regexm(slot,"Sat")==1
replace day = 3 if regexm(slot,"Sun")==1

gen     time = 1 if regexm(slot,"0100_0600")==1
replace time = 2 if regexm(slot,"0600_0930")==1
replace time = 3 if regexm(slot,"0930_1200")==1
replace time = 4 if regexm(slot,"1200_1400")==1
replace time = 5 if regexm(slot,"1400_1600")==1
replace time = 6 if regexm(slot,"1600_1800")==1
replace time = 7 if regexm(slot,"1800_2000")==1
replace time = 8 if regexm(slot,"2000_2230")==1
replace time = 9 if regexm(slot,"2230_0100")==1

egen temp = mean(price),by(time station region year month)
replace price = temp if price==.
drop temp

egen temp = mean(price),by(time station region year)
replace price = temp if price==.
drop temp

egen temp = mean(price),by(time station region)
replace price = temp if price==.
drop temp

egen temp = mean(price),by(station region)
replace price = temp if price==.
gen  temp2 = temp if region=="Wales"
egen temp3 = mean(temp2),by(region)
replace price = temp3 if price==.
drop temp2 temp3
gen  temp2 = temp if region=="West"
egen temp3 = mean(temp2),by(region)
replace price = temp3 if price==.
drop temp*

keep year month week region station slot price
sa "$PI/price_region.dta",replace

***********************************
** create a hhno index to loop over
***********************************

u "$PA/RGhhidx.dta",clear
su hhidx
local hh=r(max)
forval i=1(1)`hh' {
   u "$PI/price_national.dta",clear
   append using "$PI/price_region.dta"
   gen hhidx=`i'
   * get hhno
   so hhidx
   mer m:1 hhidx using "$PA/RGhhidx.dta",keep(match)
   drop _m
   * merge in tv region that hh lives in
   so hhno region
   mer m:1 hhno region using "$PA/RGhh_region.dta",keep(master match)
   gen w_region =_m==3
   drop _m
   * merge in slots that hh regularly watches
   so hhno slot
   mer m:1 hhno slot using "$PA/RGhh_slot.dta",keep(master match)
   gen w_slot =_m==3
   drop _m
   * merge in stations that hh regularly watches
   so hhno station
   mer m:1 hhno station using "$PA/RGhh_station.dta",keep(master match)
   gen w_station =_m==3
   drop _m
   gen     w = w_slot*w_station
   replace w = w_region*w_slot*w_station if station=="ITV1"|station=="C4"|station=="C5"

   gen wprice = w*price

   keep hhidx hhno week year month wprice
   collapse (mean) wprice,by(hhidx hhno week year month)
   compress
   if `i'>1 append using "$PI/instr_ads.dta"
   sa "$PI/instr_ads.dta",replace
}

u "$PA/RGdisagg_ad_stocks_ft.dta",clear

keep hhidx agg_brand week of_wads

merge m:1 hhidx week using "$PI/instr_ads.dta"
keep if _m==3
drop _m

*Note week is lagged by 1
keep if week>21
drop if week>95
replace week = week - 21

egen mk = group(year month)
tab agg_brand,gen(bb)

gen pringles=bb1
gen walkreg =bb2
gen otherbrd=agg_brand>2

foreach v in pringles walkreg otherbrd {
    foreach n of numlist 2(1)17 {
        gen `v'_`n' = 0
        replace `v'_`n' = `v' if mk==`n'
    }
}

foreach b of numlist 1(1)10 {
    gen wprice_`b' = 0
    replace wprice_`b' = wprice if agg_brand==`b'
}

reg of_wads wprice_1-wprice_8 wprice_10 bb2-bb10 pringles_* walkreg_* otherbrd_*
predict CF_ad_fi,res

reg of_wads wprice_2-wprice_7 wprice_10 bb2-bb10 walkreg_* otherbrd_*
predict CF_ad_fotg,res

keep hhno week agg_brand CF_ad_fi CF_ad_fotg

sa "$PI/adv_instruments.dta",replace

u "$P/FoodIn_characteristics.dta",clear

sort product week
by product: gen price_lag = price[_n-1]
replace price_lag = price if price_lag==.

gen size2 = size^2

gen     agg_brand = 1  if product==1|product==2
replace agg_brand = 2  if product==3|product==4
replace agg_brand = 3  if product==5|product==6
replace agg_brand = 4  if product==7|product==8
replace agg_brand = 5  if product==9|product==10|product==11
replace agg_brand = 6  if product==12|product==13|product==14
replace agg_brand = 7  if product==15|product==16|product==17
replace agg_brand = 8  if product==18|product==19|product==20
replace agg_brand = 9  if product==21|product==22|product==23
replace agg_brand = 10 if product==24|product==25|product==26

tab agg,gen(bb)

gen pringles=bb1
gen walkreg =bb2
gen otherbrd=agg_brand>2

egen mk = group(year month)

foreach v in pringles walkreg otherbrd {
    foreach n of numlist 2(1)17 {
        gen `v'_`n' = 0
        replace `v'_`n' = `v' if mk==`n'
    }
}

foreach n of numlist 1(1)26 {
    gen     pl_p`n' = 0
    replace pl_p`n' = price_lag if product==`n'
}

reg price pl_p1-pl_p26 bb2-bb10 size size2 pringles_* walkreg_* otherbrd_*
test _b[pl_p1]==_b[pl_p2]==_b[pl_p3]==_b[pl_p4]==_b[pl_p5]==_b[pl_p6]==_b[pl_p7]==_b[pl_p8]==_b[pl_p9]==_b[pl_p10]==_b[pl_p11]==_b[pl_p12]==_b[pl_p13]==_b[pl_p14]==_b[pl_p15]==_b[pl_p16]==_b[pl_p17]==_b[pl_p18]==_b[pl_p19]==_b[pl_p20]==_b[pl_p21]==_b[pl_p22]==_b[pl_p23]==_b[pl_p24]==_b[pl_p25]==_b[pl_p26]==0
predict CF_price, res

keep week product CF_price

sa "$PI/FoodIn_price_instrument.dta",replace

u "$P/FOTG_characteristics.dta",clear

sort product week
by product: gen price_lag = price[_n-1]
replace price_lag = price if price_lag==.

gen size2 = size^2

gen     agg_brand = 1  if product==101|product==102
replace agg_brand = 2  if product==103
replace agg_brand = 3  if product==104
replace agg_brand = 4  if product==105|product==106
replace agg_brand = 5  if product==107
replace agg_brand = 6  if product==108|product==109
replace agg_brand = 7  if product==110|product==111

tab agg,gen(bb)

gen walkreg =bb1
gen otherbrd=agg_brand>1

egen mk = group(year month)

foreach v in walkreg otherbrd {
    foreach n of numlist 2(1)17 {
        gen `v'_`n' = 0
        replace `v'_`n' = `v' if mk==`n'
    }
}

gen product2 = product-100

foreach n of numlist 1(1)11 {
    gen     pl_p`n' = 0
    replace pl_p`n' = price_lag if product2==`n'
}

reg price pl_p1-pl_p11 bb2-bb7 size size2 walkreg_* otherbrd_*
test _b[pl_p1]==_b[pl_p2]==_b[pl_p3]==_b[pl_p4]==_b[pl_p5]==_b[pl_p6]==_b[pl_p7]==_b[pl_p8]==_b[pl_p9]==_b[pl_p10]==_b[pl_p11]==0
predict CF_price, res

keep week product CF_price

sa "$PI/FOTG_price_instrument.dta",replace

**************************************************************************
**************************************************************************

**************************************************************************
**Outsheet estimation data
**************************************************************************

foreach n of numlist 1(1)11{
    u "$P/FoodIn_Estimation_group`n'.dta",clear

    egen cs = group(index)
    egen dm = group(hhno)
    egen op = group(product)
    egen mk = group(year month)

    gen othbrds = walk_sen==1|walk_dor==1|walk_oth==1|kp==1|gw==1|asda==1|tesco==1|other==1
    foreach v in pringles walk_reg othbrds outside1 {
        foreach m of numlist 2(1)17 {
            qui gen     `v'_`m' = `v' if mk==`m'
            qui replace `v'_`m' = 0 if `v'_`m'==.
        }
    }

    merge m:1 hhno week agg_brand using "$PI/adv_instruments.dta",keepusing(CF_ad_fi)
    replace CF_ad_fi = 0 if CF_ad_fi==. & _m==1
    drop if _m==2
    drop _m

    replace CF_ad_fi=CF_ad_fi/100
    replace CF_ad_fi=ln(CF_ad_fi+(CF_ad_fi^2+1)^(0.5))

    merge m:1 week product using "$PI/FoodIn_price_instrument.dta"
    replace CF_price = 0 if CF_price==.
    drop if _m==2
    drop _m

    foreach x of numlist 1 2 3 {
        gen outside2_r`x' = outside2==1 & region==`x'
    }

    replace own_stock   = own_stock/100
    replace rival_stock = rival_stock/100

    replace own_stock   = ln(own_stock+(own_stock^2+1)^(0.5))
    replace rival_stock = ln(rival_stock+(rival_stock^2+1)^(0.5))

    gen price_own_stock       = price*own_stock
    gen health_cost_own_stock = health_cost*own_stock

    gen size_sq = (size^2)/1000
    gen wk = agg_manu==2

    replace health_cost = 20 if product==199

    keep  cs dm mk op choice price own_stock rival_stock pastchoice pastmonth size size_sq price_own_stock health_cost_own_stock pringles walk_reg walk_sen walk_dor walk_oth kp gw asda tesco outside1 outside2 wk pringles_* walk_reg_* othbrds_* outside1_* outside2_r1 outside2_r2 health_cost CF_ad_fi CF_price
    order cs dm mk op choice price own_stock rival_stock pastchoice pastmonth size size_sq price_own_stock health_cost_own_stock pringles walk_reg walk_sen walk_dor walk_oth kp gw asda tesco outside1 outside2 wk pringles_* walk_reg_* othbrds_* outside1_* outside2_r1 outside2_r2 health_cost CF_ad_fi CF_price

    sort cs op
    su
    outsheet using "$PI/FoodIn_group`n'_data.raw",comma nol non replace
}

foreach n of numlist 1(1)12{
    u "$P/FOTG_Estimation_group`n'.dta",clear

    egen cs = group(index)
    egen dm = group(hhno indvno)
    egen op = group(product)
    egen mk = group(year month)

    gen othbrds = walk_sen==1|walk_dor==1|walk_oth==1|kp==1|gw==1|other==1
    foreach v in walk_reg othbrds outside1 {
        foreach m of numlist 2(1)17 {
            qui gen     `v'_`m' = `v' if mk==`m'
            qui replace `v'_`m' = 0 if `v'_`m'==.
        }
    }

    merge m:1 hhno week agg_brand using "$PI/adv_instruments.dta",keepusing(CF_ad_fotg)
    replace CF_ad_fotg = 0 if CF_ad_fotg==. & _m==1
    drop if _m==2
    drop _m

    replace CF_ad_fotg=CF_ad_fotg/100
    replace CF_ad_fotg=ln(CF_ad_fotg+(CF_ad_fotg^2+1)^(0.5))

    merge m:1 week product using "$PI/FOTG_price_instrument.dta"
    replace CF_price = 0 if CF_price==.
    drop if _m==2
    drop _m

    foreach x of numlist 1 2 3 {
        gen outside2_r`x' = outside2==1 & region==`x'
    }

    replace own_stock   = own_stock/100
    replace rival_stock = rival_stock/100

    replace own_stock   = ln(own_stock+(own_stock^2+1)^(0.5))
    replace rival_stock = ln(rival_stock+(rival_stock^2+1)^(0.5))

    gen price_own_stock       = price*own_stock
    gen health_cost_own_stock = health_cost*own_stock

    gen size_sq = (size^2)/1000

    replace health_cost = 20 if product==199

    keep  cs dm mk op choice price own_stock rival_stock pastchoice pastmonth fip size size_sq price_own_stock health_cost_own_stock walk_reg walk_sen walk_dor walk_oth kp gw outside1 outside2 walk_reg_* othbrds_* outside1_* outside2_r1 outside2_r2 health_cost CF_ad_fotg CF_price
    order cs dm mk op choice price own_stock rival_stock pastchoice pastmonth fip size size_sq price_own_stock health_cost_own_stock walk_reg walk_sen walk_dor walk_oth kp gw outside1 outside2 walk_reg_* othbrds_* outside1_* outside2_r1 outside2_r2 health_cost CF_ad_fotg CF_price

    sort cs op
    su
    outsheet using "$P/FOTG_group`n'_data.raw",comma nol non replace
}

**************************************************************************
** Outsheet computation data
**************************************************************************

****Main data
foreach n of numlist 1(1)11{
***Food in
    u "$P/FoodIn_Computations_group`n'.dta",clear

    egen cs = group(index)
    egen dm = group(hhno)
    egen op = group(product)
    egen mk = group(year month)

    gen othbrds = walk_sen==1|walk_dor==1|walk_oth==1|kp==1|gw==1|asda==1|tesco==1|other==1
    foreach v in pringles walk_reg othbrds outside1 {
        foreach m of numlist 2(1)17 {
            qui gen     `v'_`m' = `v' if mk==`m'
            qui replace `v'_`m' = 0 if `v'_`m'==.
        }
    }

    merge m:1 hhno week agg_brand using "$PI/adv_instruments.dta",keepusing(CF_ad_fi)
    replace CF_ad_fi = 0 if CF_ad_fi==. & _m==1
    drop if _m==2
    drop _m

    replace CF_ad_fi=CF_ad_fi/100
    replace CF_ad_fi=ln(CF_ad_fi+(CF_ad_fi^2+1)^(0.5))

    merge m:1 week product using "$PI/FoodIn_price_instrument.dta"
    replace CF_price = 0 if CF_price==.
    drop if _m==2
    drop _m

    foreach x of numlist 1 2 3 {
        gen outside2_r`x' = outside2==1 & region==`x'
    }

    replace own_stock   = own_stock/100
    replace rival_stock = rival_stock/100

    replace own_stock   = ln(own_stock+(own_stock^2+1)^(0.5))
    replace rival_stock = ln(rival_stock+(rival_stock^2+1)^(0.5))

    gen price_own_stock       = price*own_stock
    gen health_cost_own_stock = health_cost*own_stock

    gen size_sq = (size^2)/1000
    gen wk = agg_manu==2

    replace health_cost = 20 if product==199

    keep  cs dm mk op choice price own_stock rival_stock pastchoice pastmonth size size_sq price_own_stock health_cost_own_stock pringles walk_reg walk_sen walk_dor walk_oth kp gw asda tesco outside1 outside2 wk pringles_* walk_reg_* othbrds_* outside1_* outside2_r1 outside2_r2 health_cost CF_ad_fi CF_price
    order cs dm mk op choice price own_stock rival_stock pastchoice pastmonth size size_sq price_own_stock health_cost_own_stock pringles walk_reg walk_sen walk_dor walk_oth kp gw asda tesco outside1 outside2 wk pringles_* walk_reg_* othbrds_* outside1_* outside2_r1 outside2_r2 health_cost CF_ad_fi CF_price

    sort cs op
    su
    outsheet using "$PI/FoodIn_group`n'_comp_data.raw",comma nol non replace
}

***FOTG
foreach n of numlist 1(1)12{
    u "$P/FOTG_Computations_group`n'.dta",clear

    egen cs = group(index)
    egen dm = group(hhno indvno)
    egen op = group(product)
    egen mk = group(year month)

    gen othbrds = walk_sen==1|walk_dor==1|walk_oth==1|kp==1|gw==1|other==1
    foreach v in walk_reg othbrds outside1 {
        foreach m of numlist 2(1)17 {
            qui gen     `v'_`m' = `v' if mk==`m'
            qui replace `v'_`m' = 0 if `v'_`m'==.
        }
    }

    foreach x of numlist 1 2 3 {
        gen outside2_r`x' = outside2==1 & region==`x'
    }

    merge m:1 hhno week agg_brand using "$PI/adv_instruments.dta",keepusing(CF_ad_fotg)
    replace CF_ad_fotg = 0 if CF_ad_fotg==. & _m==1
    drop if _m==2
    drop _m

    replace CF_ad_fotg=CF_ad_fotg/100
    replace CF_ad_fotg=ln(CF_ad_fotg+(CF_ad_fotg^2+1)^(0.5))

    merge m:1 week product using "$PI/FOTG_price_instrument.dta"
    replace CF_price = 0 if CF_price==.
    drop if _m==2
    drop _m

    replace own_stock   = own_stock/100
    replace rival_stock = rival_stock/100

    replace own_stock   = ln(own_stock+(own_stock^2+1)^(0.5))
    replace rival_stock = ln(rival_stock+(rival_stock^2+1)^(0.5))

    gen price_own_stock       = price*own_stock
    gen health_cost_own_stock = health_cost*own_stock

    gen size_sq = (size^2)/1000

    replace health_cost = 20 if product==199

    keep  cs dm mk op choice price own_stock rival_stock pastchoice pastmonth fip size size_sq price_own_stock health_cost_own_stock walk_reg walk_sen walk_dor walk_oth kp gw outside1 outside2 walk_reg_* othbrds_* outside1_* outside2_r1 outside2_r2 health_cost CF_ad_fotg CF_price
    order cs dm mk op choice price own_stock rival_stock pastchoice pastmonth fip size size_sq price_own_stock health_cost_own_stock walk_reg walk_sen walk_dor walk_oth kp gw outside1 outside2 walk_reg_* othbrds_* outside1_* outside2_r1 outside2_r2 health_cost CF_ad_fotg CF_price

    sort cs op
    su
    outsheet using "$PI/FOTG_group`n'_comp_data.raw",comma nol non replace
}

log close
