**************************************************************************
**************************************************************************
**Food at home
**************************************************************************
**************************************************************************

**************************************************************************
**Mean price elasticities
**************************************************************************

insheet using "$In_in/fimelas.raw",clear

rename v1 market
rename v2 altop
rename v3 altpr
rename v4 elas

collapse (mean) elas,by(altop altpr)

lab def prod_in 1 "Pringles:150-300g"  2  "Pringles:300g+" 3 "Walkers Reg:150-300g" 4  "Walkers Reg:300g+" 5  "Walkers Sens:150-300g" 6 "Walkers Sens:300g+" 7 "Walkers Dor:150-300g" 8 "Walkers Dor:300g+" 9 "Walkers Oth:>150g"  10 "Walkers Oth:150-300g"  11 "Walkers Oth:300g+" 12 "KP:<150g"  13 "KP:150-300g"  14 "KP:300g+" 15 "Golden Wonder:<150g"  16 "Golden Wonder:150-300g"  17 "Golden Wonder:300g+" 18 "Asda: < 150g"  19 "Asda:150-300g" 20 "Asda:300g+" 21 "Tesco:<150g"  22 "Tesco:150-300g" 23 "Tesco:300g+" 24 "Other: < 150g"  25 "Other:150-300g" 26 "Other:300g+" 27 "Outside" 29 "Outside 2"
lab val altop prod_in

keep if altop==27 | altop==28 | altop<12
keep if altpr<12

reshape wide elas,i(altop) j(altpr)

gen ot = altop
replace ot = 1  if altop==3
replace ot = 2  if altop==4
replace ot = 3  if altop==5
replace ot = 4  if altop==6
replace ot = 5  if altop==7
replace ot = 6  if altop==8
replace ot = 7  if altop==9
replace ot = 8  if altop==10
replace ot = 9  if altop==11
replace ot = 10 if altop==1
replace ot = 11 if altop==2

lab def otfe 1 "Walkers Regular:150-300g" 2 "Walkers Regular:300g+" 3  "Walkers Sensations:150-300g" 4 "Walkers Sensations:300g+" 5 "Walkers Doritos:150-300g" 6 "Walkers Doritos:300g+" 7 "Walkers Other:<150g"  8 "Walkers Other:150-300g"  9 "Walkers Other:300g+" 10 "Pringles:150-300g"  11 "Pringles:300g+"  12 "KP:<150g"  13 "KP:150-300g"  14 "KP:300g+" 15 "Golden Wonder:<150g"  16 "Golden Wonder:150-300g"  17 "Golden Wonder:300g+" 18 "Asda:<150g"  19 "Asda:150-300g" 20 "Asda:300g+" 21 "Tesco:<150g"  22 "Tesco:150-300g" 23 "Tesco:300g+" 24 "Other:<150g"  25 "Other:150-300g" 26 "Other:300g+" 27 "Outside option" 28 "Outside option 2"
lab val ot otfe

tabout ot using "$T/fi_priceelas10.tex", replace sum bt ptotal(none) format(4 4 4 4 4 4 4 4 4 4) cells(mean elas3 mean elas4 mean elas5 mean elas6 mean elas7 mean elas8 mean elas9 mean elas10 mean elas11 mean elas1 mean elas2) style(tex) h1(nil) h2(&\multicolumn{2}{c}{Walkers Regular}&\multicolumn{2}{c}{Walkers Sensations}&\multicolumn{2}{c}{Walkers Doritos}&\multicolumn{3}{c}{Walkers Other}&\multicolumn{2}{c}{Pringles} \\) h3(&150-300g&300g+&150-300g&300g+&150-300g&300g+&150-300g&300g+&$<$150g&150-300g&300g+\\)

**************************************************************************
**Coefficients
**************************************************************************

insheet using "$In_in/fi_coefficents.raw",clear
rename v1  fi_hhs1_coef
rename v2  fi_hhs2_coef
rename v3  fi_hhs3_coef
rename v4  fi_hhs4_coef
rename v5  fi_hhs5_coef
rename v6  fi_hhs6_coef
rename v7  fi_hhs7_coef
rename v8  fi_hhs8_coef
rename v9  fi_hhs9_coef
rename v10 fi_hhs10_coef
rename v11 fi_hhs11_coef
rename v12 fi_hhs1_err
rename v13 fi_hhs2_err
rename v14 fi_hhs3_err
rename v15 fi_hhs4_err
rename v16 fi_hhs5_err
rename v17 fi_hhs6_err
rename v18 fi_hhs7_err
rename v19 fi_hhs8_err
rename v20 fi_hhs9_err
rename v21 fi_hhs10_err
rename v22 fi_hhs11_err
drop v23

gen     variable = 1  if _n==1
replace variable = 2  if _n==3
replace variable = 3  if _n==5

replace variable = 4  if _n==2
replace variable = 5  if _n==4
replace variable = 6  if _n==6
replace variable = 7  if _n==8
replace variable = 8  if _n==10

replace variable = 10 if _n==11
replace variable = 11 if _n==12
replace variable = 12 if _n==13
replace variable = 13 if _n==14
replace variable = 14 if _n==15
replace variable = 15 if _n==16
replace variable = 16 if _n==17
replace variable = 17 if _n==18
replace variable = 18 if _n==19
replace variable = 19 if _n==20
replace variable = 20 if _n==21
replace variable = 21 if _n==22
replace variable = 22 if _n==23
replace variable = 23 if _n==24
replace variable = 24 if _n==25
drop if (_n==7|_n==9|_n>25)

sort variable
order variable fi_hhs1_coef fi_hhs2_coef fi_hhs3_coef fi_hhs4_coef fi_hhs5_coef fi_hhs6_coef fi_hhs7_coef fi_hhs8_coef fi_hhs9_coef fi_hhs10_coef fi_hhs11_coef fi_hhs1_err fi_hhs2_err fi_hhs3_err fi_hhs4_err fi_hhs5_err fi_hhs6_err fi_hhs7_err fi_hhs8_err fi_hhs9_err fi_hhs10_err fi_hhs11_err

lab def f_c 1 "Price" 2   "Brand advertising" 3  "Competitor advertising" 4 "Price" 5   "Brand advertising" 6  "Competitor advertising" 7 "Nutrient score" 8 "Walkers" 9 "Food in purchase"  10 "Size" 11 "Size squared" 12 "Price*Brand advertising" 13 "Health cost*Brand advertising" 14 "Pringles" 15 "Walkers Regular" 16 "Walkers Sensations" 17 "Walkers Doritos" 18 "Walkers Other" 19 "KP" 20 "Golden Wonder" 21 "Asda" 22 "Tesco" 23 "Outside Option" 24 "Outside option 2"

lab val variable f_c

foreach v in fi_hhs1_coef fi_hhs2_coef fi_hhs3_coef fi_hhs4_coef fi_hhs5_coef fi_hhs6_coef fi_hhs7_coef fi_hhs8_coef fi_hhs9_coef fi_hhs10_coef fi_hhs11_coef {
    replace `v' = abs(`v') if variable==4|variable==5|variable==6|variable==7|variable==8
    replace `v' = -`v'     if variable==12
}

sa "$Out/fi_coefficents.dta",replace

**************************************************************************
**************************************************************************
**Food on-the-go
**************************************************************************
**************************************************************************

**************************************************************************
**Mean price elasticities
**************************************************************************

insheet using "$In_out/fotgmelas.raw",clear

rename v1 market
rename v2 altop
rename v3 altpr
rename v4 elas

collapse (mean) elas,by(altop altpr)

reshape wide elas,i(altop) j(altpr)

lab def prod_out_full 1 "Walkers Regular:34.5g" 2 "Walkers Regular:50g" 3 "Walkers Sensations:40g" 4 "Walkers Doritos:40g" 5 "Walkers Other:<30g" 6 "Walkers Other:30g+" 7 "KP:50g" 8 "Golden Wonder:<40g" 9 "Golden Wonder:40g+" 10 "Other:<40g" 11 "Other:40g+" 12 "Outside option" 13 "Outside option 2"
lab val altop prod_out_full

tabout altop using "$T/fotg_priceelas.tex", replace sum bt ptotal(none) format(4 4 4 4 4 4 4 4 4 4 4) cells(mean elas1 mean elas2 mean elas3 mean elas4 mean elas5 mean elas6 mean elas7 mean elas8 mean elas9 mean elas10 mean elas11) style(tex) h1(nil) h2(&\multicolumn{2}{c}{Walkers Regular}&Walkers&Walkers&\multicolumn{2}{c}{Walkers Other}&KP&\multicolumn{2}{c}{GW}&\multicolumn{2}{c}{Other} \\)  h3(& 34.5g & 50g & 40g & 40g & <30g & 30g+ & 50g & <40g & 40g+ & <40g & 40g+ \\)

**************************************************************************
**Coefficients
**************************************************************************

insheet using "$In_out/fotg_coefficents.raw",clear

rename v1  fotg_hhs1_coef
rename v2  fotg_hhs2_coef
rename v3  fotg_hhs3_coef
rename v4  fotg_hhs4_coef
rename v5  fotg_hhs5_coef
rename v6  fotg_hhs6_coef
rename v7  fotg_hhs7_coef
rename v8  fotg_hhs8_coef
rename v9  fotg_hhs9_coef
rename v10 fotg_hhs10_coef
rename v11 fotg_hhs11_coef
rename v12 fotg_hhs12_coef
rename v13 fotg_hhs1_err
rename v14 fotg_hhs2_err
rename v15 fotg_hhs3_err
rename v16 fotg_hhs4_err
rename v17 fotg_hhs5_err
rename v18 fotg_hhs6_err
rename v19 fotg_hhs7_err
rename v20 fotg_hhs8_err
rename v21 fotg_hhs9_err
rename v22 fotg_hhs10_err
rename v23 fotg_hhs11_err
rename v24 fotg_hhs12_err
drop v25

gen     variable = 1  if _n==1
replace variable = 2  if _n==3
replace variable = 3  if _n==5

replace variable = 4  if _n==2
replace variable = 5  if _n==4
replace variable = 6  if _n==6
replace variable = 7  if _n==8

replace variable = 9  if _n==9
replace variable = 10 if _n==10
replace variable = 11 if _n==11
replace variable = 12 if _n==12
replace variable = 13 if _n==13
replace variable = 15 if _n==14
replace variable = 16 if _n==15
replace variable = 17 if _n==16
replace variable = 18 if _n==17
replace variable = 19 if _n==18
replace variable = 20 if _n==19
replace variable = 23 if _n==20
replace variable = 24 if _n==21
drop if (_n==7|_n>21)

sort variable
order variable fotg_hhs1_coef fotg_hhs2_coef fotg_hhs3_coef fotg_hhs4_coef fotg_hhs5_coef fotg_hhs6_coef fotg_hhs7_coef fotg_hhs8_coef fotg_hhs9_coef fotg_hhs10_coef fotg_hhs11_coef fotg_hhs12_coef fotg_hhs1_err fotg_hhs2_err fotg_hhs3_err fotg_hhs4_err fotg_hhs5_err fotg_hhs6_err fotg_hhs7_err fotg_hhs8_err fotg_hhs9_err fotg_hhs10_err fotg_hhs11_err fotg_hhs12_err

lab val variable f_c

foreach v in fotg_hhs1_coef fotg_hhs2_coef fotg_hhs3_coef fotg_hhs4_coef fotg_hhs5_coef fotg_hhs6_coef fotg_hhs7_coef fotg_hhs8_coef fotg_hhs9_coef fotg_hhs10_coef fotg_hhs11_coef fotg_hhs12_coef {
    replace `v' = abs(`v') if variable==4|variable==5|variable==6|variable==7
    replace `v' = -`v'     if variable==12
}

sa "$Out/fotg_coefficents.dta",replace

**************************************************************************
**************************************************************************
***Generate results tables for appendix
**************************************************************************
**************************************************************************

**************************************************************************
***Coefficients
**************************************************************************

u "$Out/fi_coefficents.dta",clear

merge 1:1 variable using "$Out/fotg_coefficents.dta"
drop _m

reshape long fi_hhs1 fi_hhs2 fi_hhs3 fi_hhs4 fi_hhs5 fi_hhs6 fi_hhs7 fi_hhs8 fi_hhs9 fi_hhs10 fi_hhs11 fotg_hhs1 fotg_hhs2 fotg_hhs3 fotg_hhs4 fotg_hhs5 fotg_hhs6 fotg_hhs7 fotg_hhs8 fotg_hhs9 fotg_hhs10 fotg_hhs11 fotg_hhs12,i(variable) j(coeff) string

replace variable = 2*variable-1
replace variable = variable+1 if coeff=="_err"

lab def c 1 "Price" 2 "" 3   "Brand advertising" 4 "" 5  "Competitor advertising" 6 "" 7 "Price" 8 "" 9   "Brand advertising" 10 "" 11  "Competitor advertising" 12 "" 13 "Nutrient score" 14 "" 15 "Walkers" 16 "" 17 "Food in purchase" 18 "" 19 "Size" 20 "" 21 "Size squared" 22 "" 23 "Price*Brand advertising" 24 "" 25 "Health cost*Brand advertising" 26 "" 27 "Pringles" 28 "" 29 "Walkers Regular" 30 "" 31 "Walkers Sensations" 32 "" 33 "Walkers Doritos" 34 "" 35 "Walkers Other" 36 "" 37 "KP" 38  "" 39 "Golden Wonder" 40  "" 41 "Asda" 42  "" 43 "Tesco" 44  "" 45 "Unhealthy Outside" 46  "" 47 "Healthy Outside" 48 ""
lab val variable c

gen inonly  = variable==15|variable==16|variable==27|variable==28|variable==41|variable==42|variable==43|variable==44
gen outonly = variable==17|variable==18

tabout variable using "$T/coefficients_1.tex" if outonly==0, replace sum bt ptotal(none) format(4) cells(mean fi_hhs1 mean fi_hhs2 mean fi_hhs3 mean fi_hhs4 mean fi_hhs5 mean fi_hhs6) style(tex) h1(nil) h2(&No kids, high inc.,&No kids, medium inc.,&No kids, low inc.,&No kids, high-medium inc.,&No kids, low inc.,&Pensioners \\) h3(&high sk.&high sk.&high sk.&low sk.&low sk.&\\)

tabout variable using "$T/coefficients_2.tex" if outonly==0, replace sum bt ptotal(none) format(4) cells(mean fi_hhs7 mean fi_hhs8 mean fi_hhs9 mean fi_hhs10 mean fi_hhs11) style(tex) h1(nil) h2(&Kids, high inc.,&Kids, medium inc.,&Kids, low inc.,&Kids, high-med inc.,&Kids, low inc.,\\) h3(&high sk.&high sk.&high sk.&low sk.&low sk.\\)

tabout variable using "$T/coefficients_3.tex" if inonly==0 , replace sum bt ptotal(none) format(4) cells(mean fotg_hhs1 mean fotg_hhs2 mean fotg_hhs3 mean fotg_hhs4 mean fotg_hhs5 mean fotg_hhs6) style(tex) h1(nil) h2(&No kids, high inc.,&No kids, medium inc.,&No kids, low inc.,&No kids, high-medium inc.,&No kids, low inc.,&Pensioners \\) h3(&high sk.&high sk.&high sk.&low sk.&low sk.&\\)

tabout variable using "$T/coefficients_4.tex" if inonly==0 , replace sum bt ptotal(none) format(4) cells(mean fotg_hhs7 mean fotg_hhs8 mean fotg_hhs9 mean fotg_hhs10 mean fotg_hhs11 mean fotg_hhs12) style(tex) h1(nil) h2(&Kids, high inc.,&Kids, medium inc.,&Kids, low inc.,&Kids, high-med inc.,&Kids, low inc.,&Kid\\) h3(&high sk.&high sk.&high sk.&low sk.&low educ&purchaser \\)

**************************************************************************
***Marginal costs
**************************************************************************

forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/products.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/product_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/products.dta"
    replace b = `v' if b==.

    sa "$Out/product_append_ci.dta",replace

}

u "$Out/product_append_ci.dta",clear

merge m:1 b using "$Out/bs_index.dta"
keep if _m==3
drop _m

collapse (mean) costs margin,by(product b)

foreach v in costs margin {
    egen `v'lb = pctile(`v'),p(2.5) by(product)
    egen `v'ub = pctile(`v'),p(97.5) by(product)
}

bysort product: keep if _n==1
keep product costslb marginlb costsub marginub

reshape long costs margin,i(product) j(stat) string

sa "$Out/products_ci.dta",replace

u "$Out/products.dta",clear

collapse (mean) price costs margin,by(product)

gen stat = "mean"

append using "$Out/products_ci.dta"

lab def prod_all_full 1 "Pringles:150-300g"  2  "Pringles:300g+" 3 "Walkers Regular:150-300g" 4  "Walkers Regular:300g+" 5  "Walkers Sensations:150-300g" 6 "Walkers Sensations:300g+" 7 "Walkers Doritos:150-300g" 8 "Walkers Doritos:300g+" 9 "Walkers Other:<150g"  10 "Walkers Other:150-300g"  11 "Walkers Other:300g+" 12 "KP:<150g"  13 "KP:150-300g"  14 "KP:300g+" 15 "Golden Wonder:<150g"  16 "Golden Wonder:150-300g"  17 "Golden Wonder:300g+" 18 "Asda:<150g"  19 "Asda:150-300g" 20 "Asda:300g+" 21 "Tesco:<150g"  22 "Tesco:150-300g" 23 "Tesco:300g+" 24 "Other:<150g"  25 "Other:150-300g" 26 "Other:300g+" 101 "Walkers Regular:34.5g" 102 "Walkers Regular:50g" 103 "Walkers Sensations:40g" 104 "Walkers Doritos:40g" 105 "Walkers Other:<30g" 106 "Walkers Other:30g+" 107 "KP:50g" 108 "Golden Wonder:<40g" 109 "Golden Wonder:40g+" 110 "Other:<40g" 111 "Other:40g+" 112 "Outside option"
lab val product prod_all_full

foreach v in price costs margin {
    gen `v'out=round(`v',0.01)
    format `v'out %4.2f
    }
drop price costs margin

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide priceout costsout marginout, i(product) j(stat)

foreach v in costs margin {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep product priceout2 costsout2 marginout2 CIcosts CImargin
gen o=""

gen ot = product
replace ot = 1  if product==3
replace ot = 2  if product==4
replace ot = 3  if product==5
replace ot = 4  if product==6
replace ot = 5  if product==7
replace ot = 6  if product==8
replace ot = 7  if product==9
replace ot = 8  if product==10
replace ot = 9  if product==11
replace ot = 10 if product==1
replace ot = 11 if product==2

lab def otmc 1 "Walkers Regular:150-300g" 2 "Walkers Regular:300g+" 3  "Walkers Sensations:150-300g" 4 "Walkers Sensations:300g+" 5 "Walkers Doritos:150-300g" 6 "Walkers Doritos:300g+" 7 "Walkers Other:<150g"  8 "Walkers Other:150-300g"  9 "Walkers Other:300g+" 10 "Pringles:150-300g"  11 "Pringles:300g+"  12 "KP:<150g"  13 "KP:150-300g"  14 "KP:300g+" 15 "Golden Wonder:<150g"  16 "Golden Wonder:150-300g"  17 "Golden Wonder:300g+" 18 "Asda:<150g"  19 "Asda:150-300g" 20 "Asda:300g+" 21 "Tesco:<150g"  22 "Tesco:150-300g" 23 "Tesco:300g+" 24 "Other:<150g"  25 "Other:150-300g" 26 "Other:300g+"
lab val ot otmc

local z=1
*forvalues x=1/26 {
forvalues x=1/11 {
    local productname  :   label  (ot)   `x'
    if `z'==1 listtab  priceout2 costsout2 marginout2  using "$T/costs_in.tex" in `x' , begin(`productname'&)  rstyle(tabular)  replace
    if `z'>1  listtab  priceout2 costsout2 marginout2  in `x'  , begin(`productname'&)  rstyle(tabular)  appendto("$T/costs_in.tex" )
    listtab  o CIcosts CImargin in `x' ,   rstyle(tabular)  appendto("$T/costs_in.tex")   begin(&)
    local z=`z'+1
    }

drop if product<100
local z=1
foreach x of numlist 101 102 103 104 105 106 107 108 109 110 111 {
    local productname  :   label  (product)   `x'
    if `z'==1 listtab  priceout2 costsout2 marginout2  using "$T/costs_out.tex" in `z' , begin(`productname'&)  rstyle(tabular)  replace
    if `z'>1  listtab  priceout2 costsout2 marginout2  in `z'  , begin(`productname'&)  rstyle(tabular)  appendto("$T/costs_out.tex" )
    listtab  o CIcosts CImargin in `z' ,   rstyle(tabular)  appendto("$T/costs_out.tex")   begin(&)
    local z=`z'+1
    }

**************************************************************************
***By firm results
**************************************************************************

forval v = 1/$BR {

    if `v'==1 u "$OutAll/Bootstrap/`v'/firmsimulations.dta",clear
    if `v'==1 gen b = 1

    if `v'>1 u "$Out/firmsimulations_append_ci.dta",clear
    if `v'>1 append using "$OutAll/Bootstrap/`v'/firmsimulations.dta"
    replace b = `v' if b==.

    sa "$Out/firmsimulations_append_ci.dta",replace
}

u "$Out/firmsimulations_append_ci.dta",clear

merge m:1 b using "$Out/bs_index.dta"
keep if _m==3
drop _m

drop var

foreach v in Pringles Walkers KP Golden_Wonder Asda Tesco Other {
    egen `v'lb = pctile(`v'),p(2.5) by(vr)
    egen `v'ub = pctile(`v'),p(97.5) by(vr)
}

bysort vr: keep if _n==1
keep vr Pringleslb Walkerslb KPlb Golden_Wonderlb Asdalb Tescolb Otherlb Pringlesub Walkersub KPub Golden_Wonderub Asdaub Tescoub Otherub

reshape long Pringles Walkers KP Golden_Wonder Asda Tesco Other,i(vr) j(stat) string

sa "$Out/firmsimulations_ci.dta",replace

u "$Out/firmsimulations.dta",clear

drop var

gen stat = "mean"

append using "$Out/firmsimulations_ci.dta"

foreach v in Pringles Walkers KP Golden_Wonder Asda Tesco Other {
    gen `v'out=round(`v',0.01)
    format `v'out %4.2f
    }
drop Pringles Walkers KP Golden_Wonder Asda Tesco Other

encode stat, gen(t1)
drop stat
ren t1 stat

reshape wide Pringlesout Walkersout KPout Golden_Wonderout Asdaout Tescoout Otherout, i(vr) j(stat)

foreach v in Pringles Walkers KP Golden_Wonder Asda Tesco Other {
    tostring `v'out1, gen(t1) force usedisplayformat
    tostring `v'out3, gen(t2) force usedisplayformat
    gen CI`v'="["+t1+", "+t2+"]"
    drop t1 t2
    }

keep vr Pringlesout2 Walkersout2 KPout2 Golden_Wonderout2 Asdaout2 Tescoout2 Otherout2 CIPringles CIWalkers CIKP CIGolden_Wonder CIAsda CITesco CIOther

lab def f 1 "Advertising expenditure (\pounds m)" 2 "Price (\pounds)" 3 "Quantity (mKg)" 4 "Profits (\pounds m)" 5 "\% change in quantity" 6 "\% change in profits" 7 "\% change in price" 8  "\% change in quantity" 9 "\% change in profits"

lab val vr f

local z=1
forvalues x=1/4 {
    local vrname  :   label  (vr)   `x'
    if `z'==1 listtab  Walkersout2 Pringlesout2 KPout2 Golden_Wonderout2 Asdaout2 Tescoout2 Otherout2  using "$T/firmsimulations1.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `z'>1  listtab  Walkersout2 Pringlesout2 KPout2 Golden_Wonderout2 Asdaout2 Tescoout2 Otherout2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$T/firmsimulations1.tex" )
    if `z'!=1 listtab  CIWalkers CIPringles CIKP CIGolden_Wonder CIAsda CITesco CIOther in `x' ,   rstyle(tabular)  appendto("$T/firmsimulations1.tex")   begin(&)
    local z=`z'+1
    }

forvalues x=5/6 {
    local vrname  :   label  (vr)   `x'
    if `x'==5 listtab  Walkersout2 Pringlesout2 KPout2 Golden_Wonderout2 Asdaout2 Tescoout2 Otherout2  using "$T/firmsimulations2.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `x'>5  listtab  Walkersout2 Pringlesout2 KPout2 Golden_Wonderout2 Asdaout2 Tescoout2 Otherout2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$T/firmsimulations2.tex" )
    listtab  CIWalkers CIPringles CIKP CIGolden_Wonder CIAsda CITesco CIOther in `x' ,   rstyle(tabular)  appendto("$T/firmsimulations2.tex")   begin(&)
    }

forvalues x=7/9 {
    local vrname  :   label  (vr)   `x'
    if `x'==7 listtab  Walkersout2 Pringlesout2 KPout2 Golden_Wonderout2 Asdaout2 Tescoout2 Otherout2  using "$T/firmsimulations3.tex" in `x' , begin(`vrname'&)  rstyle(tabular)  replace
    if `x'>7  listtab  Walkersout2 Pringlesout2 KPout2 Golden_Wonderout2 Asdaout2 Tescoout2 Otherout2  in `x'  , begin(`vrname'&)  rstyle(tabular)  appendto("$T/firmsimulations3.tex" )
    listtab  CIWalkers CIPringles CIKP CIGolden_Wonder CIAsda CITesco CIOther in `x' ,   rstyle(tabular)  appendto("$T/firmsimulations3.tex")   begin(&)
    }
	