clear all
set more off

**Set globals

global path "C:/DuboisGriffithOConnell.2017.ReStud"

**Main
global OFile1 "MainResults"
**Instruments
global OFile2 "Instruments"

global OFile $OFile1

global FoodInMF "$path/Matlab_files/$OFile/FoodIn"
global FOTGMF   "$path/Matlab_files/$OFile/FOTG"

global OutAll   "$path/Stata_files\Results/$OFile"
global T		"$path/Stata_files\Results/Tables"

global Progs    "$path\Programs\Results"
global Data     "$path\Stata_files\Estimation"
global DataA    "$path\Stata_files\Advertising"

**Market size
global Insize  "2140*0.47"
global Outsize "4060*0.47"
***Number of bootstrap
global BR      "100"

do "$Progs/PrelimFiles.do"

global In_in  $FoodInMF
global In_out $FOTGMF
global Out    $OutAll

do "$Progs/MainResults.do"
do "$Progs/WillingnessToPay.do"
do "$Progs/AdvertisingEffect.do"

forval v = 1/$BR {

    global In_in  "$FoodInMF/bootstrap_fi/`v'"
    global In_out "$FOTGMF/bootstrap_fotg/`v'"
    global Out    "$OutAll/Bootstrap/`v'"

        capture confirm file "$Out/nul"
        if _rc>0 {
            mkdir "$Out"
        }

        do "$Progs/MainResults.do"
        do "$Progs/WillingnessToPay.do"
        do "$Progs/AdvertisingEffect.do"
}

global Out    $OutAll

do "$Progs/Tables.do"

global In_in  $FoodInMF
global In_out $FOTGMF

do "$Progs/DataSection.do"
do "$Progs/Appendix.do"

*********************
**Robustness
*********************
**do "$Progs/Linkeddemand.do"

global OFile $OFile2

global FoodInMF "$path/Matlab_files/$OFile/FoodIn"
global FOTGMF   "$path/Matlab_files/$OFile/FOTG"

global OutAll   "$path/Stata_files\ForPaper\Results/$OFile"
global Out      $OutAll

do "$Progs/ControlFunction_AdEffect.do"

forval v = 1/$BR {

    global In_in  "$FoodInMF/bootstrap_fi/`v'"
    global In_out "$FOTGMF/bootstrap_fotg/`v'"
    global Out    "$OutAll/Bootstrap/`v'"

        capture confirm file "$Out/nul"
        if _rc>0 {
            mkdir "$Out"
        }

        do "$Progs/ControlFunction_AdEffect.do"
}
do "$Progs/ControlFunction_Tables.do"
