
**************************************************************************
**Food in coefficients
**************************************************************************

insheet using "$In_in/fi_coefficents.raw",clear

keep v1-v11
rename v1  fi_hhs1_coef
rename v2  fi_hhs2_coef
rename v3  fi_hhs3_coef
rename v4  fi_hhs4_coef
rename v5  fi_hhs5_coef
rename v6  fi_hhs6_coef
rename v7  fi_hhs7_coef
rename v8  fi_hhs8_coef
rename v9  fi_hhs9_coef
rename v10 fi_hhs10_coef
rename v11 fi_hhs11_coef

gen     variable = 1  if _n==1
replace variable = 2  if _n==3
replace variable = 3  if _n==5

replace variable = 4  if _n==2
replace variable = 5  if _n==4
replace variable = 6  if _n==6
replace variable = 7  if _n==8
replace variable = 8  if _n==10

replace variable = 10 if _n==11
replace variable = 11 if _n==12
replace variable = 12 if _n==13
replace variable = 13 if _n==14
replace variable = 14 if _n==15
replace variable = 15 if _n==16
replace variable = 16 if _n==17
replace variable = 17 if _n==18
replace variable = 18 if _n==19
replace variable = 19 if _n==20
replace variable = 20 if _n==21
replace variable = 21 if _n==22
replace variable = 22 if _n==23
replace variable = 23 if _n==24
replace variable = 24 if _n==25
drop if (_n==7|_n==9|_n>25)

sort variable
order variable fi_hhs1_coef fi_hhs2_coef fi_hhs3_coef fi_hhs4_coef fi_hhs5_coef fi_hhs6_coef fi_hhs7_coef fi_hhs8_coef fi_hhs9_coef fi_hhs10_coef fi_hhs11_coef

lab def f_c 1 "Price" 2   "Brand advertising" 3  "Competitor advertising" 4 "Price" 5   "Brand advertising" 6  "Competitor advertising" 7 "Nutrient score" 8 "Walkers" 9 "Food in purchase"  10 "Size" 11 "Size squared" 12 "Price*Brand advertising" 13 "Health cost*Brand advertising" 14 "Pringles" 15 "Walkers Regular" 16 "Walkers Sensations" 17 "Walkers Doritos" 18 "Walkers Other" 19 "KP" 20 "Golden Wonder" 21 "Asda" 22 "Tesco" 23 "Outside Option" 24 "Outside option 2"
lab val variable f_c

foreach v in fi_hhs1_coef fi_hhs2_coef fi_hhs3_coef fi_hhs4_coef fi_hhs5_coef fi_hhs6_coef fi_hhs7_coef fi_hhs8_coef fi_hhs9_coef fi_hhs10_coef fi_hhs11_coef {
    replace `v' = abs(`v') if variable==4|variable==5|variable==6|variable==7|variable==8
    replace `v' = -`v'     if variable==12
}

sa "$Out/fi_coefficents.dta",replace

**************************************************************************
**Food on the go coefficients
**************************************************************************

insheet using "$In_out/fotg_coefficents.raw",clear

keep v1-v12
rename v1  fotg_hhs1_coef
rename v2  fotg_hhs2_coef
rename v3  fotg_hhs3_coef
rename v4  fotg_hhs4_coef
rename v5  fotg_hhs5_coef
rename v6  fotg_hhs6_coef
rename v7  fotg_hhs7_coef
rename v8  fotg_hhs8_coef
rename v9  fotg_hhs9_coef
rename v10 fotg_hhs10_coef
rename v11 fotg_hhs11_coef
rename v12 fotg_hhs12_coef

gen     variable = 1  if _n==1
replace variable = 2  if _n==3
replace variable = 3  if _n==5

replace variable = 4  if _n==2
replace variable = 5  if _n==4
replace variable = 6  if _n==6
replace variable = 7  if _n==8

replace variable = 9  if _n==9
replace variable = 10 if _n==10
replace variable = 11 if _n==11
replace variable = 12 if _n==12
replace variable = 13 if _n==13
replace variable = 15 if _n==14
replace variable = 16 if _n==15
replace variable = 17 if _n==16
replace variable = 18 if _n==17
replace variable = 19 if _n==18
replace variable = 20 if _n==19
replace variable = 23 if _n==20
replace variable = 24 if _n==21
drop if (_n==7|_n>21)

sort variable
order variable fotg_hhs1_coef fotg_hhs2_coef fotg_hhs3_coef fotg_hhs4_coef fotg_hhs5_coef fotg_hhs6_coef fotg_hhs7_coef fotg_hhs8_coef fotg_hhs9_coef fotg_hhs10_coef fotg_hhs11_coef fotg_hhs12_coef

lab val variable f_c

foreach v in fotg_hhs1_coef fotg_hhs2_coef fotg_hhs3_coef fotg_hhs4_coef fotg_hhs5_coef fotg_hhs6_coef fotg_hhs7_coef fotg_hhs8_coef fotg_hhs9_coef fotg_hhs10_coef fotg_hhs11_coef fotg_hhs12_coef {
    replace `v' = abs(`v') if variable==4|variable==5|variable==6|variable==7
    replace `v' = -`v'     if variable==12
}

sa "$Out/fotg_coefficents.dta",replace

clear
set obs 20
gen variable = 0
keep if _n==1
sa "$Data/temp_hc.dta",replace

u "$Out/fi_coefficents.dta",clear

**Price
forvalues n=1/11 {
    su fi_hhs`n'_coef if variable==1
    local pm`n'=r(mean)
}
forvalues n=1/11 {
    su fi_hhs`n'_coef if variable==4
    local ps`n'=r(mean)
}

**Nutrient score
forvalues n=1/11 {
    su fi_hhs`n'_coef if variable==7
    local hs`n'=r(mean)
}

**Price*own advertising
forvalues n=1/11 {
    su fi_hhs`n'_coef if variable==12
    local pam`n'=r(mean)
}

**Health cost*own advertising
forvalues n=1/11 {
    su fi_hhs`n'_coef if variable==13
    local ham`n'=r(mean)
}

keep if var>=14
append using "$Data/temp_hc.dta"

foreach n of numlist 1(1)11{
    replace fi_hhs`n'_coef = 0 if var==0
}

gen     brand = 1  if variable==14
replace brand = 2  if variable==15
replace brand = 3  if variable==16
replace brand = 4  if variable==17
replace brand = 5  if variable==18
replace brand = 6  if variable==19
replace brand = 7  if variable==20
replace brand = 8  if variable==21
replace brand = 9  if variable==22
replace brand = 10 if variable==0
replace brand = 11 if variable==23
replace brand = 12 if variable==24

lab def brand 1 "Pringles" 2 "Walkers Reg" 3 "Walkers Sens" 4 "Walkers Dor" 5 "Walkers Oth" 6 "KP" 7 "GW" 8 "Asda" 9 "Tesco" 10 "Other" 11 "Outside" 12 "Outside 2"
lab val brand brand

drop variable
order brand

merge 1:1 brand using "$Data/health_cost_FoodIn.dta"
drop _m
replace health_cost = 20 if brand==11
replace health_cost = 0  if brand==12

foreach n of numlist 1(1)11 {
    rename fi_hhs`n'_coef delta`n'
}
reshape long delta,i(brand) j(group)

keep brand group delta health_cost

gen  temp1 = delta if brand==12
egen temp2 = min(temp1),by(group)

replace delta = delta-temp2

drop if brand==12
drop temp*

reg delta health_cost

local hm=_b[health_cost]

u "$Data/ad_for_wtp.dta",clear

su p10
local ad_p10=r(mean)
su p50
local ad_p50=r(mean)
su p90
local ad_p90=r(mean)

clear
set obs 3001

gen     group = 1  if _n<=413
replace group = 2  if _n<=683  & _n>413
replace group = 3  if _n<=928  & _n>683
replace group = 4  if _n<=1121 & _n>928
replace group = 5  if _n<=1410 & _n>1121
replace group = 6  if _n<=1652 & _n>1410
replace group = 7  if _n<=2019 & _n>1652
replace group = 8  if _n<=2295 & _n>2019
replace group = 9  if _n<=2442 & _n>2295
replace group = 10 if _n<=2724 & _n>2442
replace group = 11 if            _n>2724

gen fotg = 0

set seed 244

gen alpha0i = .
gen alpha1 = .

gen phi0i = .
gen phi1 = .

foreach n of numlist 1(1)11 {
    drawnorm alpha0i_`n',mean(`pm`n'') sd(`ps`n'')
    replace alpha0i_`n'=-exp(alpha0i_`n')
    gen alpha1_`n' = `pam`n''

    drawnorm phi0i_`n',mean(`hm') sd(`hs`n'')
    gen phi1_`n' = `ham`n''

    replace alpha0i = alpha0i_`n' if group==`n'
    replace alpha1  = alpha1_`n'  if group==`n'

    replace phi0i = phi0i_`n' if group==`n'
    replace phi1  = phi1_`n'  if group==`n'
}

gen adv_p10 = `ad_p10'
gen adv_p50 = `ad_p50'
gen adv_p90 = `ad_p90'

gen wtp_base = phi0i/alpha0i
gen wtp_rp10 = (phi0i+phi1*adv_p10)/(alpha0i+alpha1*adv_p10)
gen wtp_rp50 = (phi0i+phi1*adv_p50)/(alpha0i+alpha1*adv_p50)
gen wtp_rp90 = (phi0i+phi1*adv_p90)/(alpha0i+alpha1*adv_p90)

foreach v in 10 50 90 {
    replace wtp_rp`v' = wtp_rp`v'-wtp_base
}

gen out = 0

sa "$Out/fi_wtp.dta",replace

u "$Out/fotg_coefficents.dta",clear

**Price
forvalues n=1/12 {
    su fotg_hhs`n'_coef if variable==1
    local pm`n'=r(mean)
}
forvalues n=1/12 {
    su fotg_hhs`n'_coef if variable==4
    local ps`n'=r(mean)
}

**Nutrient score
forvalues n=1/12 {
    su fotg_hhs`n'_coef if variable==7
    local hs`n'=r(mean)
}

**Price*own advertising
forvalues n=1/12 {
    su fotg_hhs`n'_coef if variable==12
    local pam`n'=r(mean)
}

**Health cost*own advertising
forvalues n=1/12 {
    su fotg_hhs`n'_coef if variable==13
    local ham`n'=r(mean)
}

keep if var>=14
append using "$Data/temp_hc.dta"

foreach n of numlist 1(1)12{
    replace fotg_hhs`n'_coef = 0 if var==0
}

gen     brand = 1  if variable==14
replace brand = 2  if variable==15
replace brand = 3  if variable==16
replace brand = 4  if variable==17
replace brand = 5  if variable==18
replace brand = 6  if variable==19
replace brand = 7  if variable==20
replace brand = 8  if variable==21
replace brand = 9  if variable==22
replace brand = 10 if variable==0
replace brand = 11 if variable==23
replace brand = 12 if variable==24


lab def brand 1 "Pringles" 2 "Walkers Reg" 3 "Walkers Sens" 4 "Walkers Dor" 5 "Walkers Oth" 6 "KP" 7 "GW" 8 "Asda" 9 "Tesco" 10 "Other" 11 "Outside" 12 "Outside 2"
lab val brand brand

drop variable
order brand

merge 1:1 brand using "$Data/health_cost_FOTG.dta"
drop _m
replace health_cost = 20 if brand==11
replace health_cost = 0 if brand==12

foreach n of numlist 1(1)12 {
    rename fotg_hhs`n'_coef delta`n'
}
reshape long delta,i(brand) j(group)

gen  temp1 = delta if brand==12
egen temp2 = min(temp1),by(group)

replace delta = delta-temp2

drop if brand==12

reg delta health_cost

local hm=_b[health_cost]

u "$Out/fotg_products.dta",replace

su mean_trs_ad if brand==1
local ad_wr=r(mean)

su mean_trs_ad if brand==5
local ad_kp=r(mean)

clear
set obs 2551

gen     group = 1  if _n<=302
replace group = 2  if _n<=525  & _n>302
replace group = 3  if _n<=750  & _n>525
replace group = 4  if _n<=902  & _n>750
replace group = 5  if _n<=1136 & _n>902
replace group = 6  if _n<=1270 & _n>1136
replace group = 7  if _n<=1593 & _n>1270
replace group = 8  if _n<=1817 & _n>1593
replace group = 9  if _n<=1943 & _n>1817
replace group = 10 if _n<=2199 & _n>1943
replace group = 11 if _n<=2456 & _n>2199
replace group = 12 if            _n>2456

gen fotg = 1

set seed 245

gen alpha0i = .
gen alpha1 = .

gen phi0i = .
gen phi1 = .

foreach n of numlist 1(1)12 {
    drawnorm alpha0i_`n',mean(`pm`n'') sd(`ps`n'')
    replace alpha0i_`n'=-exp(alpha0i_`n')
    gen alpha1_`n' = `pam`n''

    drawnorm phi0i_`n',mean(`hm') sd(`hs`n'')
    gen phi1_`n' = `ham`n''

    replace alpha0i = alpha0i_`n' if group==`n'
    replace alpha1  = alpha1_`n'  if group==`n'

    replace phi0i = phi0i_`n' if group==`n'
    replace phi1  = phi1_`n'  if group==`n'
}

gen adv_p10 = `ad_p10'
gen adv_p50 = `ad_p50'
gen adv_p90 = `ad_p90'

gen wtp_base = phi0i/alpha0i
gen wtp_rp10 = (phi0i+phi1*adv_p10)/(alpha0i+alpha1*adv_p10)
gen wtp_rp50 = (phi0i+phi1*adv_p50)/(alpha0i+alpha1*adv_p50)
gen wtp_rp90 = (phi0i+phi1*adv_p90)/(alpha0i+alpha1*adv_p90)

foreach v in 10 50 90 {
    replace wtp_rp`v' = wtp_rp`v'-wtp_base
}

gen out = 1

sa "$Out/fotg_wtp.dta",replace

u "$Out/fi_products.dta",clear

drop if product==27|product==28

egen base = sum(share),by(market)
replace share = share/base

replace price = price*share

collapse (sum) price,by(market)

su price

local pin = r(mean)

u "$Out/fotg_products.dta",clear

drop if product==12|product==13

egen base = sum(share),by(market)
replace share = share/base

replace price = price*share

collapse (sum) price,by(market)

su price

local pout = r(mean)

u "$Out/fotg_wtp.dta",clear

append using "$Out/fi_wtp.dta"

lab def out 0 "Food in the home" 1 "Food on the go"
lab val out out

*foreach v in wtp_base wtp_WK_Reg wtp_KP {
foreach v in wtp_rp10 wtp_rp50 wtp_rp90 {
    replace `v' = `v'*100
}

collapse (median) wtp_rp10 wtp_rp50 wtp_rp90,by(out)

foreach v in wtp_rp10 wtp_rp50 wtp_rp90 {
    gen `v'p = .
    replace `v'p = `v'/`pin' if out==0
    replace `v'p = `v'/`pout' if out==1
    rename `v' `v'd
}

reshape long wtp_rp10 wtp_rp50 wtp_rp90,i(out) j(change) string

egen vr = group(out change)

order vr out change wtp*

sa "$Out/wtp.dta",replace
